;
; This file is released under the terms of the GNU General Public License
; as they appear in http://www.gnu.org/licenses/gpl.txt.
;
; Copyright 2007, 2008, 2009, 2010 erwin.rieger@ibrieger.de
;

;
; xxx todo:
; * remove jahrBuchCheck
; * remove get-this-year
; * csv export: output verzeichnis/path konfigurierbar (mit options machbar?)
;

;
; $Log: ibr-gnc-module.scm,v $
; Revision 1.44  2011/01/03 19:45:26  bh
; Anpassungen fuer GnuCash 2.3.15, guid's fuer gnc:make-menu-item und gnc:make-extension.
;
; Revision 1.43  2010/03/08 19:00:44  bh
; Rework CSV export, strip numbers, output full description.
;
; Revision 1.42  2010/02/14 15:17:57  bh
; Wieder-aktiveirung Test Jahres-Abschluss.
;
; Revision 1.41  2010/02/14 12:11:49  bh
; Dokumentation csv-export.
;
; Revision 1.40  2010/02/11 16:48:44  bh
; Anlagen Spiegel auf geaenderte konto-hierarchie angepasst.
;
; Revision 1.39  2010/02/10 16:07:12  bh
; CSV Nochmals NoExport Flag, Konto umbenennung mit ExportKNR Flag.
;
; Revision 1.38  2010/02/08 22:17:59  bh
; CSV Export ueberarbeitet, NoExport Flag wird nun beruecksichtigt.
;
; Revision 1.37  2010/02/08 14:57:31  bh
; Anlagen Spiegel reaktiviert
;
; Revision 1.36  2010/01/13 09:45:38  bh
; Dokumentation fuer buchungs-check.
;
; Revision 1.35  2010/01/10 17:33:50  bh
; Buchungscheck: UND-verknuepfung von konten (mehrere GK descvalues) nun moeglich.
;
; Revision 1.34  2010/01/10 15:34:06  bh
; Buchungscheck: oder-verknuepfung von konten (GK descvalue) nun moeglich.
;
; Revision 1.33  2010/01/10 14:28:53  bh
; Neuer bericht 'Buchungen Pruefen', cleanup.
;
; Revision 1.32  2009/07/27 15:44:28  bh
; Optionen Datumsbereich fuer UST Pruefung und UST Buchungen eingebaut.
;
; Revision 1.31  2009/05/08 15:56:32  bh
; save work
;
; Revision 1.30  2009/04/03 11:39:42  bh
; Test Jahresuebergaenge entfernt.
;
; Revision 1.29  2009/04/03 10:41:34  bh
; Test Jahresuebergaenge ok
;
; Revision 1.28  2009/03/10 19:23:28  bh
; Save before report-guid change for 2.2.8.
;
; Revision 1.27  2009/03/08 18:12:01  bh
; scheme-modul: test jahresabschluss
;
; Revision 1.26  2009/03/06 09:11:49  bh
; save work
;
; Revision 1.25  2009/01/02 19:02:50  bh
; Eigene string-replace-char funktion, ist in GC 2.2.0/2.2.4 nicht definiert.
;
; Revision 1.24  2009/01/01 09:44:06  bh
; Umstellung auf GC 2.2.6.; UST pruefung.
;
; Revision 1.23  2008/12/28 13:10:29  bh
; Umstellung auf GC 2.2.6.
;
; Revision 1.22  2008/11/30 11:52:28  bh
; Commit for umstellung auf GC 2.2.6
;
; Revision 1.21  2008/05/02 15:33:31  bh
; Descvalue USTK UST VSTK VST.
;
; Revision 1.18  2008/04/30 13:55:23  bh
; mwst berechnung
;
; Revision 1.17  2008/02/25 10:56:37  bh
; Umstellung speicherung kontonummer.
;
; Revision 1.16  2008/02/06 10:51:19  bh
; Umstellung auf Gnucash Kontonummer
;
; Revision 1.15  2008/02/06 04:14:35  bh
; Umstellung auf Gnucash Kontonummer
;
; Revision 1.14  2008/02/05 13:00:30  bh
; Cleanup
;
; Revision 1.13  2008/01/28 22:07:12  bh
; Save Work
;
; Revision 1.12  2008/01/22 13:11:16  bh
; Save Work
;
; Revision 1.11  2007/10/23 07:49:08  bh
; Added CVS header.
;
; Revision 1.19  2008/05/02 07:51:47  bh
; Umstellung speicherung kontonummer.
;
; Revision 1.20  2008/05/02 10:40:48  bh
; Umstellung speicherung kontonummer.
;
;

;
; Scheme tutorial: A guided tour - to get a flavor of what it is:
; http://www.drscheme.org/tour/tour-Z-H-2.html
;

(printf "Start ibr-gnc-module.scm\n")

(gnc:module-load "gnucash/business-utils" 0)

(use-modules (sw_report_system))
(gnc:module-load "gnucash/report/report-system" 0)

;
; Report-Guid's created with gnucash-make-guids
;
(define ust-check-guid "83d4104ad149ee4301ea545b075d78ce")
(define ust-auto-guid "45bc8986b90ac8fdf4e12f48e8e7cbe8")
(define ja-guid "07c381b543f02d425cbe35d358db575b")
;;;;;;;(define ju-guid "4a1726e5b2d8be38af744366b11f4214")
(define csv-export-guid "8200c42352489524c776a1352d01c678")
(define afa-spiegel-guid "4dabd98eefb65f81efcbad5858962621")
(define afa-vorbereitung-guid "3e09c11f9506a4250c9e0523a1749d84")
(define afa-uebernahme-guid "e3ac44ac1379a7f2126a90af13495b44")
(define buchungs-check-guid "96b9e8a04f786e8b1f6bfd5101716775")

;
; Menu-Guid's
;
(define buchungs-check-menu-guid "590c9f3f475af2cae8521b677f931c20")
(define ust-check-menu-guid "007a10721668e208086f08e9f897a2f6")
(define ja-menu-guid "c5ca2f905af8d00a2d7accff09fb5040")
(define csv-export-menu-guid "d951dfb02abc2a82f192c6f928f5ea5e")
(define afa-spiegel-menu-guid "9b28348edf9d912ed96f4c462e05586e")
(define afa-vorbereitung-menu-guid "c62419c2c00ce924c1edac28e1b8ed2d")
(define reload-ibr-gnc-module-menu-guid "d935555b873d42b8b8ce002ad9dd4674")

;
; Extension-Guid's
;
(define cc-sep-guid "f7bba99fb7c0daad88824044a637b98c")
(define dd-sep-guid "3b91ed5a95ba7eafb7fcc98851d9e628")
(define ff-sep-guid "f13a4f0d985d025ca42d613f3c55b8d7")

; 3d21c96fd340b0ff385fce6cf3fb22cc
; abc44b72077c1467baa406463fdd4f82
; 0e532714e80a90f9b9d62c17635beb4e
; cfebb451bab278813a389aaff655bbbc
; 44d8fb47693b254c63a8156ea97b6ef6
; a056a13127f45c8badbd7488a9f78d76
;
(define optname-from-date (N_ "From"))
(define optname-to-date (N_ "To"))
(define optname-enter-tax-splits (N_ "Fehlende UST Buchungen anlegen"))
(define optname-run-cvs-export (N_ "Daten im CSV format exportieren"))

; Drei verschiedene bank konten, 1800/1810 bank, 1600 kasse 
; xxx und 2199 einlagen
(define (is-bank-knr knr)
    (or (string=? (substring knr 0 2) "18") (string=? (substring knr 0 2) "16"))
)

; Verschiedene vorsteuer konten, 1401_7%, 1400_16% und 1400_15%
;,,,,,(define (is-vorsteuer-knr knr)
    ;,,,,,; (string=? (substring knr 0 3) "140")
    ;,,,,,(false-if-exception (string=? (substring knr 0 3) "140"))
;,,,,,)

; Verschiedene ust konten, 3800_16% und 3800_15%
; (define (is-ust-knr knr)
    ; (string=? (substring knr 0 3) "380")
; )
;
; Konto ueber kontonummoer oder kontobeschreibung (datev nummer) suchen
; xxx find-acc-in-childs-by-code durch find-acc-in-acclist-by-code ersetzen
(define (find-acc-in-acclist-by-code accountlist accountcode)

  (if (null? accountlist)

    #f

    (let (
            (account (car accountlist))
        )

        ; (printf "find-acc-in-acclist-by-code search: %s, code: %s, desc: %s\n" accountcode (xaccAccountGetCode account) (xaccAccountGetDescription account))

        (if (or (string=? accountcode (xaccAccountGetCode account)) (string=? accountcode (xaccAccountGetDescription account)))
            account
            (find-acc-in-acclist-by-code (cdr accountlist) accountcode)
        )
    )
  )
)


; Liefert eur ust konto fuer steuersatz
(define (get-eur-ust-konto ustsatz)
    (find-acc-by-code (string-append "9994_" (number->string ustsatz) "%"))
)

; Zugehoeriges afa konto fuer gegebenes anlagen konto finden
(define (get-afa-account-knr doc account)
    (let (
            (splitted (string-split (get-account-knr doc account) #\|))
        )
        (if (> (length splitted) 0)
            (list-ref splitted 0)
            #f
        )
    )
)

; Zugehoeriges anfangs-bestands konto fuer gegebenes anlagen konto finden
(define (get-anf-account-knr doc account)
    (let (
            (splitted (string-split (get-account-knr doc account) #\|))
        )
        (if (> (length splitted) 1)
            (list-ref splitted 1)
            #f
        )
    )
)

(define (is-bank-split doc split)
    (is-bank-knr (get-split-knr doc split))
)

;,,,,,(define (is-vorsteuer-split doc split)
    ;,,,,,(is-vorsteuer-knr (get-split-knr doc split))
;,,,,,)

; (define (is-ust-split doc split)
    ; (is-ust-knr (get-split-knr doc split))
; )

; 0
(define numeric0 (gnc-numeric-zero))
; 1
(define numeric1 (double-to-gnc-numeric 1 100 GNC-RND-ROUND))
; 100
(define numeric100 (double-to-gnc-numeric 100 100 GNC-RND-ROUND))

;
; Liefert datev kontonummer zu account,
; die gnucash kontonummer falls vorhanden
;
(define (get-account-knr doc account)
    (let (
            (knr (xaccAccountGetCode account))
        )

        (if (= (string-length knr) 4)
            knr
            (if (= (length (xaccAccountGetSplitList account)) 0)
                knr
                (begin
                    ; Account hat keine knr oder knr hat weniger als 4 stellen, fehler falls das konto
                    ; buchungen enthaelt

                    (html-add-text doc "<br>" (redText "ERROR") ", Konto: '" (xaccAccountGetName account) "' hat eine ungueltige Kontonummer!<br><br>")
                    "0000"
                )
            )
        )
    )
)

; liefert datev kontonummer zu split (= kontobeschreibung)
(define (xxx-get-split-knr doc split)

    ; Splits ohne account (?!) abfangen
    (if (xaccSplitGetAccount split)
        (get-account-knr doc (xaccSplitGetAccount split))
        "NO_ACCOUNT_IN_SPLIT"
    )
)

(define (get-split-knr doc split)

    ; Splits ohne account (?!) abfangen
    (if (xaccSplitGetAccount split)
        (get-account-knr doc (xaccSplitGetAccount split))
        "NO_ACCOUNT_IN_SPLIT"
    )
)

; ausgabe html text
(define (html-add-text doc . text)
    (gnc:html-document-add-object! doc
        (gnc:make-html-text-internal text (gnc:make-html-style-table)))
)

; ausgabe transaktion mit link
(define (html-add-trn doc trn)
    (printf "transaction num in html-add-trn: '%s'\n" (xaccTransGetNum trn))
    (gnc:html-document-add-object! doc (gnc:html-transaction-anchor trn (gnc-print-date (gnc-transaction-get-date-posted trn))))
    (gnc:html-document-add-object! doc "; ")
    (gnc:html-document-add-object! doc (xaccTransGetDescription trn))
)

(define (redText text)
    (string-append "<font color=\"red\">" text "</font>")
)

(define (greenText text)
    (string-append "<font color=\"green\">" text "</font>")
)

; numeric in text umwandeln, fuer html ausgabe
(define (num-to-text num)
    (gnc:default-html-gnc-numeric-renderer num #f)
)

; numeric mit waehrung in text umwandeln, fuer html ausgabe
(define (num-comm-to-text num comm)
    (string-append (num-to-text num) " " (gnc-commodity-get-mnemonic comm))
)

(define (num-account-comm-to-text num acc)
    (num-comm-to-text num (xaccAccountGetCommodity acc))
)

; Liefert alle anlagen accounts, ohne GWG
(define (get-anlagen-konten)
    (gnc-account-get-descendants-sorted (find-acc-by-code "0100"))
)

; Liefert alle anlagen accounts, mit GWG
;; (define (get-anlagen-konten-gwg book)
    ;; (gnc-account-get-descendants-sorted (find-acc-in-childs-by-code (gnc:book-get-group (gnc:session-get-book session)) "0000"))
;; )
(define (get-anlagen-konten-gwg book)
    (let (
            (root-account (gnc-book-get-root-account book))
        )
        (gnc-account-get-descendants-sorted (find-acc-by-code-with-root-account root-account "0000"))
    )
)


; Pruefung, ob jahrbuch geoeffnet
(define (jahrBuchIsOpen doc)
    (if (afa-book-opened doc)
        (begin
            (html-add-text doc "Aktuelles Buch ist kein Jahrbuch !<br>")
            #f
        )
        #t
    )
)

; Pruefung, ob afa buch geoeffnet
(define (afaBuchIsOpen doc)
    (if (afa-book-opened doc)
        #t
        (begin
            (html-add-text doc "Aktuelles Buch ist kein AFA Buch !<br>")
            #f
        )
    )
)

; xxx remove
; Pruefung vorbedingungen fuer aktionen im jahrbuch
(define (jahrBuchCheck doc)
    (and (buchCheck doc) (jahrBuchIsOpen doc))
)

; Pruefung ob afa konten vorhanden
(define (afaKontenCheck doc)
    (let (
            (anlagenaccounts (get-anlagen-konten))
            (result #t)
        )
        ; (display anlagenaccounts) (printf "<afa-anlaccounts\n")

        (if (equal? anlagenaccounts '())
            (begin
                (html-add-text doc "Keine Anlagenkonten gefunden !<br>")
                result #f
            )
        )
        (map (lambda (acc)
                (let (
                        (afa-knr (get-afa-account-knr doc acc))
                        (anf-knr (get-anf-account-knr doc acc))
                    )

                    (if (not (find-acc-by-code afa-knr))
                        (begin
                            (html-add-text doc "Afa Konto " afa-knr " nicht gefunden !<br>")
                            result #f
                        )
                    )

                    (if (not (find-acc-by-code anf-knr))
                        (begin
                            (html-add-text doc "Anfangsbest. Konto " anf-knr " nicht gefunden !<br>")
                            result #f
                        )
                    )
                )
            )
            anlagenaccounts
        )
        result
    )
)

; xxx remove
; Pruefung vorbedingungen fuer aktionen im afabuch
(define (afaBuchCheck doc)
    (and (buchCheck doc) (afaBuchIsOpen doc) (afaKontenCheck doc))
)

; Pruefung vorbedingungen fuer aktionen im jahrbuch und im afabuch
(define (buchCheck doc)
    (let (
            (thisyear (get-this-year (gnc-get-current-book)))
            ; (accgroup (gnc:book-get-group (gnc-get-current-book)))
            (result #t)
        )

        (if (not thisyear)
            (begin
                (html-add-text doc "Aktuelles Buchungsjahr konnte nicht festgestellt werden (keine buchungen) !<br>")
                (set! result #f)
            )
        )
        ; (if (not (find-acc-in-childs-by-code accgroup "9999"))
            ; (begin
                ; (html-add-text doc "Konto 9999 nicht gefunden !<br>")
                ; (set! result #f)
            ; )
        ; )
        result
    )
)

;; (define (find-acc-in-group-by-desc account-group accountdesc)
    ;; (let (
            ;; ; (children-list (gnc:group-get-account-list account-group))
            ;; (children-list (gnc-account-get-children account-group))
        ;; )
        ;; (if (not (null? children-list))
            ;; (find-acc-in-childs-by-code children-list accountdesc)
            ;; #f
        ;; )
    ;; )
;; )

; Konto ueber kontobeschreibung (datev nummer) suchen
; (define (find-acc-in-childs-by-code accountlist code)
    ; (let (
            ; (account (car accountlist))
            ; (restlist (cdr accountlist))
        ; )

        ; (printf "find account, %s code %s\n" code (xaccAccountGetCode account))

        ; (if (string=? code (xaccAccountGetCode account))
            ; account
            ; (let (
                    ; (acc (find-acc-in-group-by-code (gnc-account-get-children account) code))
                    ; (acc (find-acc-in-group-by-code account code))
                ; )
                ; (printf "after find-acc-in-group-by-code\n")
                ; (if (and (not acc) (not (null? restlist)))
                    ; (find-acc-in-childs-by-code restlist code)
                    ; acc
                ; )
            ; )
        ; )
    ; )
; )

;; (define (find-acc-in-group-by-code account-group code)
    ;; (let (
            ;; ; (children-list (gnc:group-get-account-list account-group))
            ;; (children-list (gnc-account-get-children account-group))
        ;; )
        ;; (if (not (null? children-list))
            ;; (find-acc-in-childs-by-code children-list code)
            ;; #f
        ;; )
    ;; )
;; )


; Suche account mit bestimmter kontonummer.
(define (find-acc-by-code-with-root-account root-account code)
    (let (
            (all-accounts (gnc-account-get-descendants-sorted root-account))
        )
        (find-acc-in-acclist-by-code all-accounts code)
    )
)

; Wie find-acc-by-code-with-root-account, jedoch mit current-root-account.
; xxx replace find-acc-in-group-by-code with this:
(define (find-acc-by-code code)
    (find-acc-by-code-with-root-account (gnc-get-current-root-account) code)
)

; Oeffnet session, liefert #f falls datei nicht vorhanden
; xxx funktioniert nicht: (gnc:url->loaded-session path #f #f)
(define (openSession path)
  (let* (
            (session (qof-session-new))
        )

        ; Clear session-error flag
        (if (qof-session-has-error session)
            (qof-session-pop-error session)
        )
    
        ; Wir ignorieren locks hier, die session sollte also nur fuer read only
        ; zugriffe verwendet werden !
        (qof-session-begin session path #t #f)

        ; (if (gw:enum-<gnc:BackendError>-val->sym (gnc:session-get-error session) #f)
        (if (not (qof-session-has-error session))
            (begin
                (gnc-session-scm-load session)
                ; (if (gw:enum-<gnc:BackendError>-val->sym (gnc:session-get-error session) #f)
                (if (not (qof-session-has-error session))
                    session
                    (begin
                        (qof-session-destroy session)
                        #f
                    )
                )
            )
            (begin
                (qof-session-destroy session)
                #f
            )
        )
    )
)

; Oeffnet session, oder liefert die aktuelle session
(define (openSessionOrCurrent name)
    (let (
            (cursession (gnc-get-current-session)) ; use our new call !
            (path (gnc-book-path name))
        )

        (printf "path to open: %s, current open: %s\n" path (qof-session-get-url cursession))
        (if (string=? path (qof-session-get-url cursession))
            cursession ; return current session
            (openSession path) ; open new session
        )
    )
)

; Schliesst session falls es nicht die aktuelle session ist
(define (closeSessionNotCurrent session)
    (let (
        (curpath (qof-session-get-url (gnc-get-current-session)))
        (path (qof-session-get-url session))
        )
        (if (not (string=? curpath path))
          (begin
            ; Done by session-destroy: (gnc:session-end session)
            (qof-session-destroy session)
           )
        )
    )
)


; transaktion mit nummer num im account suchen
(define (query-by-account-and-num book account num)
    (let ( 
            ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
            (splits #f)
        )
        (qof-query-set-book query book)
        (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
        (xaccQueryAddNumberMatch query num 0 1 QOF-QUERY-AND)

        (set! splits (xaccQueryGetSplitsUniqueTrans query))
        (qof-query-destroy query)
        splits
    )
)

(define (jaTestNullSaldo doc konto date)
    (let (
            ; (saldo (xaccAccountGetBalance konto))
            (saldo (gnc:account-get-balance-at-date konto date #t))
        )

        (if (gnc-numeric-zero-p saldo)
            (html-add-text doc 
                "Saldo ist 0 in Konto '" (xaccAccountGetName konto) "' (" (get-account-knr doc konto) ") " (greenText "OK") "<br>")
            (html-add-text doc 
                "Saldo ist nicht 0 in Konto '" (xaccAccountGetName konto) "' (" (get-account-knr doc konto) "): "
                (num-account-comm-to-text saldo konto)
                " " (redText "NOTOK") "<br>")
        )
    )
)

; liefert fuer gegebenes konto den dafuer relevanten steuersatz, oder 0
(define (get-ust-satz-from-knr knr)
    (let ( 
            (splitted (string-split knr #\_))
        )

        (printf "splitted:")
        (display splitted)
        (printf "\n")

        (if (> (length splitted) 1)
            (let (
                    (satz (list-ref (string-split (list-ref splitted 1) #\%) 0))
                )
                ; (printf "get-ust-satz-from-acc-desc: steuersatz fuer konto %s: %s\n" knr satz)
                (string->number satz)
            )
            0
        )
    )
)

(define (xxx-get-ust-satz-from-split doc split)
    (get-ust-satz-from-knr (xxx-get-split-knr doc split))
)

(define (get-desc-value key doc account searchParents)

    (let (
            (result #f)
        )

        (if (not (null? account))
            (begin

                ; (display account)
                ; (printf "<<get-desc-value account\n")
                ; (printf "<<get-desc-value account-desc: %s/%s\n" (xaccAccountGetName account) (xaccAccountGetDescription account))

                (map (lambda (token)
                        (let (
                                (splitted (string-split token #\=))
                            )
                
                            ; (printf "<<get-desc-value token:%s\n" token)
                            (if (string-ci=? (list-ref splitted 0) key)
                                ; Eintraege ohne wert (boolean) beachten
                                (if (> (length splitted) 1)
                                    (set! result (list-ref splitted 1))
                                    (set! result "TRUE")
                                )
                            )
                        )
                    )
                    (string-split (xaccAccountGetDescription account) #\ )
                )

                (if (and (not result) searchParents)
                    ; parents durchsuchen
                    (if (gnc-account-get-parent account)
                        (set! result (get-desc-value key doc (gnc-account-get-parent account) #t))
                    )
                )

                ; (if result
                    ; (printf "get-desc-value %s:'%s'\n" key result)
                ; )
            )
        )
        result
    )
)

;
; Wie get-desc-value, liefert aber liste mit ggf. mehreren descvalues
; zurueck.
;
(define (get-desc-values key doc account)

    (let (
            (result '())
        )

        ; (display account)
        ; (printf "<<get-desc-value account\n")
        ; (printf "<<get-desc-value account-desc: %s/%s\n" (xaccAccountGetName account) (xaccAccountGetDescription account))

        (map 
            (lambda (token)
                (let
                    (
                        (splitted (string-split token #\=))
                    )
        
                    ; (printf "<<get-desc-value token:%s\n" token)
                    (if (string-ci=? (list-ref splitted 0) key)
                        ; Eintraege ohne wert (boolean) beachten
                        (if (> (length splitted) 1)
                            (set! result (append result (list (list-ref splitted 1))))
                            (set! result (append result (list "TRUE")))
                        )
                    )
                )
            )
            (string-split (xaccAccountGetDescription account) #\ )
        )

        ; Parents durchsuchen
        (if (not (equal? account (gnc-get-current-root-account)))
            (if (gnc-account-get-parent account)
                (set! result (append result (get-desc-values key doc (gnc-account-get-parent account))))
            )
        )

        result
    )
)

(define (get-desc-numeric-value key doc account)

    (let (
            (stringval (get-desc-value key doc account #t))
        )
        (if stringval
            (string->number stringval)
            #f
        )
    )
)
 
(define (get-gegenkonto-by-desc-value doc key account)

    (let (
            (gk-account-knr (get-desc-value key doc account #t))
        )

        (if gk-account-knr
            (find-acc-by-code gk-account-knr)
            #f
        )
    )
)


; besorgt descvalue mit schluessel key aus gegenkonto
; gegenkonto wird durch descvalue mit dem schluessel kkey bestimmt
(define (get-gegenkonto-desc-value doc kkey key account)

    (let (
            (gegenkonto (get-gegenkonto-by-desc-value doc kkey account))
        )

        (if gegenkonto
            (get-desc-value key doc gegenkonto #t)
            #f
        )
    )
)

; (define (get-gegenkonto-desc-value doc kkey key account)

    ; (let (
            ; (gk-account-knr (get-desc-value kkey doc account #t))
        ; )

        ; (if gk-account-knr
            ; (let (
                    ; (gegenkonto (find-acc-by-code gk-account-knr))
                ; )

                ; (if gegenkonto
                    ; (get-desc-value key doc gegenkonto #t)
                    ; #f
                ; )
            ; )
            ; #f
        ; )
    ; )
; )

(define (get-gegenkonto-desc-numeric-value doc kkey key account)

    (let (
            (stringval (get-gegenkonto-desc-value doc kkey key account))
        )

        ; (printf "stringval: %s" stringval)

        (if stringval
            (string->number stringval)
            #f
        )
    )
)

(define (get-account-desc-numeric-value-from-split doc key split)

    (get-desc-numeric-value key doc (xaccSplitGetAccount split))
)

(define (unused-get-ust-satz-from-account doc account)

    (let (
            (ust (get-desc-value "Mwst" doc account #t))
        )

        (printf "ust<")
        (display ust)
        (printf ">\n")

        (if ust
            (string->number ust)
            0
        )
    )
)

; berechne umsatzsteuer ausgehend vom brutto wert, z.b. x * 16 / 116
(define (get-ust-from-brutto value ustsatz)
    (let (
            (ustnumeric (double-to-gnc-numeric ustsatz 100 GNC-RND-ROUND))
            (ust-value #f)
            (nenner #f)
        )
        (set! ust-value (gnc-numeric-mul value ustnumeric 100 GNC-RND-ROUND))
        (set! nenner (gnc-numeric-add-fixed ustnumeric numeric100))
        (gnc-numeric-div ust-value nenner 100 GNC-RND-ROUND)
    )
)

; berechne umsatzsteuer ausgehend vom netto wert, z.b. x * 16 / 100
(define (get-ust-from-netto value ustsatz)
    (let (
            (ustnumeric (double-to-gnc-numeric ustsatz 100 GNC-RND-ROUND))
            (ust-value #f)
        )
        (set! ust-value (gnc-numeric-mul value ustnumeric 100 GNC-RND-ROUND))
        (gnc-numeric-div ust-value numeric100 100 GNC-RND-ROUND)
    )
)

(define (numeric-delta-compare a b delta)
    (let (
            (value-diff (gnc-numeric-sub-fixed a b))
        )
        (<= (gnc-numeric-to-double (gnc-numeric-abs value-diff)) delta)
    )
)

; xxx remove
; aktuelles jahr wird aus existierenden buchungen extrahiert, es muss also mind.
; eine buchung vorhanden sein
(define (get-this-year book)
    (let (
            ; (query (gnc:malloc-query))
            (query (qof-query-create-for-splits))
            (splits #f)
        )

          ; (xaccQueryAddAccountMatch query accounts QOF-GUID-MATCH-ANY QOF-QUERY-AND)
          ; (set! xtns (xaccQueryGetTransactions query QUERY-TXN-MATCH-ALL))


        (qof-query-set-book query (gnc-get-current-book))
        (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())
        (set! splits (xaccQueryGetSplitsUniqueTrans query))
        ; (gnc:free-query query)
        (qof-query-destroy query)

        (if (not (null? splits))
            (gnc:timepair-get-year (gnc-transaction-get-date-posted (xaccSplitGetParent (car splits))))
            #f
        )
    )
)

; xxx remove
; Waehrung, die dem jahr entspricht, DM bis 2001, ab 2002 EUR
(define (get-currency-for-year year)
    (let (
            (commodity-table (gnc-commodity-table-get-table (gnc-get-current-book)))
        )
        (if (> year 2001)
            ;(gnc:get-euro)
            (gnc-commodity-table-lookup commodity-table "ISO4217" "EUR")
            (gnc-commodity-table-lookup commodity-table "ISO4217" "DEM")
        )
    )
)

; Umrechnung DEM-DEM oder DEM-EUR, fehler bei EUR-DEM
(define (comm-umrechnung doc quell-konto value ziel-comm)
    (let (
            ; quellwaehrung aus akt. konto
            (quell-comm (xaccAccountGetCommodity quell-konto))
        )

        (if (not (waehrungs-vergleich quell-comm ziel-comm))
            (if (ist-euro-waehrung quell-comm)
                (begin
                    (html-add-text doc (redText "ERROR") ", umrechnung von EUR in DM !, Quellkonto: " 
                        (xaccAccountGetName quell-konto) "' (" (get-account-knr doc quell-konto) ") <br>")
                    numeric0
                )
                ; umrechnung DM -> EUR
                (gnc-convert-to-euro quell-comm value)
            )
            value
        )
    )
)

(define (notused)
        ; Vorsteuer
        (let (
                ; (eurvorsteuerkonto (find-acc-in-childs-by-code (gnc-account-get-children root-account) "9998"))
                (eurvorsteuerkonto (find-acc-by-code "9998"))
                (eurvorsteuersaldo #f)
                (vorsteuer numeric0)
                ; (ausgabenaccounts (gnc-account-get-descendants-sorted (find-acc-in-childs-by-code root-account "6002")))
                ; (ausgabenaccounts (gnc-account-get-descendants-sorted (find-acc-in-childs-by-code (gnc-account-get-children root-account) "6000")))
                (ausgabenaccounts (gnc-account-get-descendants-sorted (find-acc-by-code "6000")))
            )
            (set! eurvorsteuersaldo (xaccAccountGetBalance eurvorsteuerkonto))


;;;;;;;;;;;;;,,XXXXXX
;;;;;;;;;;;;;,,neuer ansatz, der gleichzeitig ausgaben und afa/gwg-einkaeufe erschlaegt:
;;;;;;;;;;;;;,,* gehe ueber alle trn/splits,
;;;;;;;;;;;;;,,* summiere vst mittels (set! ustsatz (get-account-desc-numeric-value-from-split doc "VST" split)) auf
;;;;;;;;;;;;;,,* vergleiche mit saldo aus konto 9998
;;;;;;;;;;;;;,,XXX  fuer konto 9998 ein descvalue einfuehren



            ; Ausgaben, schleife ueber alle ausgaben konten:
            (for-each (lambda (account)
                    (let (
                            (saldo (xaccAccountGetBalance account))
                            (ustsatz (get-ust-satz-from-knr (get-account-knr doc account)))
                            (ustnumeric #f)
                        )

                        ; (printf "ust-satz: %d\n" ustsatz)
                        (set! ustnumeric (double-to-gnc-numeric ustsatz 100 GNC-RND-ROUND))

                        ; ust berechnen
                        (set! saldo (gnc-numeric-mul saldo ustnumeric 100 GNC-RND-ROUND)) ; z.B. x * 16
                        (set! saldo (gnc-numeric-div saldo numeric100 100 GNC-RND-ROUND)) ; / 100

                        ; aufsummieren, hier kann kein rundungsfehler passieren
                        (set! vorsteuer (gnc-numeric-add-fixed vorsteuer saldo))
                        ; (printf "xxxvorsteuer: %s, sum: %s\n" (gnc-numeric-to-string  saldo) (gnc-numeric-to-string  vorsteuer))
                    )
                )
                ausgabenaccounts
            )

            (printf "vorsteuer 1: %s\n" (gnc-numeric-to-string vorsteuer))
            ; Eingekaufte anlagen
            (let (
                    ; (query (gnc:malloc-query))
	                (query (qof-query-create-for-splits))
                    (anlagenaccounts (get-anlagen-konten-gwg (gnc-get-current-book)))
                )

                (qof-query-set-book query (gnc-get-current-book))
                (xaccQueryAddAccountMatch query anlagenaccounts QOF-GUID-MATCH-ANY QOF-QUERY-AND)

                ; schleife ueber alle gefundenen buchungen
                (map (lambda (trn)
                        (let (
                                (ustsatz #f)
                                (bank-split-value numeric0)
                            )

                            ; bank und ust split suchen
                            (map (lambda (split)
                                    (if (is-bank-split doc split)
                                        ; den bank - split mit dem brutto einkaufswert der anlage gefunden
                                        ; ggf. mehrere splits in trn aufsummieren
                                        (set! bank-split-value (gnc-numeric-add-fixed bank-split-value (xaccSplitGetValue split)))
                                    )
                                    (set! ustsatz (get-account-desc-numeric-value-from-split doc "VST" split))
                                )
                                (xaccTransGetSplitList trn)
                            )

                            ;;;;;;; falls es ein einkauf ist ...
                            ;;;;;;(if bank-split-value
                                ;if (> ustsatz 0)
                                (if ustsatz
                                    (begin
                                        (printf "afa einkauf: bank-value: %s, ust satz: %d\n" (gnc-numeric-to-string bank-split-value) ustsatz)
                                        ; aufsummieren
                                        (set! vorsteuer (gnc-numeric-add-fixed vorsteuer 
                                            (gnc-numeric-neg (get-ust-from-brutto bank-split-value ustsatz))))
                                        ; (printf "xxxvorsteuer: %s , sum: %s\n" (gnc-numeric-to-string  (gnc-numeric-neg (get-ust-from-brutto bank-split-value ustsatz))) (gnc-numeric-to-string  vorsteuer))
                                    )
                                )
                                ; geht nicht, afa eroeffnung wird als fehler erkannt:
                                ;   (begin
                                    ;   (html-add-text doc (redText "Warnung:") " AFA - Einkauf '")
                                    ;   (html-add-trn doc trn)
                                    ;   (html-add-text doc "' ohne mehrwertsteuer buchung !<br><br>")
                                ;   )
                            ;;;;;;)
                        )
                    )

                    (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
                )

                (qof-query-destroy query)
            )

            (printf "vorsteuer2: %s\n" (gnc-numeric-to-string vorsteuer))

            (if (numeric-delta-compare vorsteuer eurvorsteuersaldo 1)
                (html-add-text doc
                    "Ausgaben Vorsteuer Verprobung ist " (greenText "OK") "<br>")
                (begin
                    (html-add-text doc
                        "Berechnete Vorsteuer: " (num-account-comm-to-text vorsteuer eurvorsteuerkonto)
                        " ist ungleich EUR Vorsteuer: " (num-account-comm-to-text eurvorsteuersaldo eurvorsteuerkonto)
                        " " (redText "NOTOK") "<br>")
                )
            )

            (html-add-text doc "<br>")

            ; auch bei verkauf afa faellt ust an !
            (html-add-text doc "xxx afa verkaufs test nicht implementiert !<br><br>")
        )

)


; Hook for reload
(define (jaRenderer report-obj)
    (jaPruefung report-obj)
)

; Pruefung auf korrekten jahresabschluss
(define (jaPruefung report-obj)
    (let* (
            (doc (gnc:make-html-document))
            ; (root-account (gnc:book-get-group (gnc-get-current-book)))
            (root-account (gnc-get-current-root-account))
            ; summe eingenommene ust ueber alle ust steuersaetze
            (summe-eurust numeric0)
            ; Summe vorsteuer aus allen einkaeufen
            (vorsteuer numeric0)

            ;;;; ; 1.1.thisyear
            ;;;; (startdate (get-timepair-at-date 0 0 0 1 1 (get-this-year (gnc-get-current-book))))
            ;;;; ; 31.12.thisyear
            ;;;; (enddate (get-timepair-at-date 59 59 23 31 12 (get-this-year (gnc-get-current-book))))

            (startdate (gnc:timepair-start-day-time
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-from-date))))
            (enddate (gnc:timepair-end-day-time 
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-to-date))))

            ; (eurvorsteuerkonto (find-acc-by-code "9998"))
            ; (eurvorsteuersaldo (xaccAccountGetBalance eurvorsteuerkonto))
            (eurvorsteuersaldo numeric0)
        )
        (html-add-text doc "<h2>Ergebnis Pruefung des Jahresabschluss:</h2>")

        (html-add-text doc "Vom " (gnc-print-date startdate) " bis " (gnc-print-date enddate) "</p>")

        (html-add-text doc "<p><h4>Pruefe Saldierungen (NullSaldo-Flag):</h4></p>")

        ; Saldierung auf 0 pruefen
        (map (lambda (account)

                (printf "Saldierung auf 0 pruefen, acc: %s %s\n" (xaccAccountGetCode account) (xaccAccountGetDescription account))

                (jaTestNullSaldo doc account enddate)
            )
            (find-accounts-has-desc-value-no-descendants doc "NullSaldo")
        )

        ; eur verprobung
        (html-add-text doc "<p><h4>Umsatzsteuer Verprobung:</h4></p>")

        ;
        ; Eingenommene Umsatzsteuer
        ;

        ;
        ; Errechne je nach ustsatz die umsatzsteuer aus den steuerpflichtigen einnahmen konten und vergleiche
        ; mit dem entsprechenden UST konto.
        ;
        (let (
                ; Alle steuerpflichtige einnahmen accounts
                ; (einnahmenaccounts (gnc-account-get-descendants-sorted (find-acc-by-code "4002")))
                (einnahmenaccounts (find-accounts-has-desc-value doc "USTK"))
                ; Speichert berechneten ust werte fuer die einnahmen konten, key: ust-satz value: summe-ust
                (ust-summen (make-hash-table 1))
                ; Speichert ust-konten, key: ust-satz value: konto
                (ust-konten (make-hash-table 1))
            )

            ;
            ; Im ersten schritt errechnen wir die eingenommene UST aus netto-summe des kontos und dem enstprechenden
            ; UST-satz:
            ;
            (map (lambda (eureinkonto)
                    ; eingenommene ust:
                    (let (
                            ; Umsatzsteuer satz des einnahmen kontos
                            ; (ustsatz (get-ust-satz-from-knr (get-account-knr doc eureinkonto)))
                            (ustsatz (get-desc-numeric-value "UST" doc (get-gegenkonto-by-desc-value doc "USTK" eureinkonto)))
                            (ustkonto (get-gegenkonto-by-desc-value doc "USTK" eureinkonto))
                        )

                        (html-add-text doc "Konto " (xaccAccountGetName eureinkonto) " ...<br>")

                        ; Einnahmen konto ist ust maessig relevant
                        (if ustsatz
                            (let (
                                    ; Netto betrag des einnahmen kontos
                                    ; (eureinsaldo (xaccAccountGetBalance eureinkonto))
                                    (eureinsaldo (gnc:account-get-balance-interval eureinkonto startdate enddate #f))
                                    (ustnumeric (double-to-gnc-numeric ustsatz 100 GNC-RND-ROUND))
                                    (ust-value #f)
                                )
                                ; Ust fuer einnahmen konto berechnen
                                (set! ust-value (gnc-numeric-mul eureinsaldo ustnumeric 100 GNC-RND-ROUND)) ; z.B. x * 16
                                (set! ust-value (gnc-numeric-div ust-value numeric100 100 GNC-RND-ROUND)) ; / 100

                                ; aufsummieren
                                ; (hash-set! ust-summen ustsatz (gnc-numeric-add-fixed (hash-ref ust-summen ustsatz) ust-value))
                                (hash-set-add-numeric ust-summen ustsatz ust-value)
                                (hash-set! ust-konten ustsatz ustkonto)
                            )
                            (html-add-text doc
                                "Fehler, ust-satz fuer konto " (xaccAccountGetName eureinkonto) " nicht gefunden! " (redText "NOTOK") "<br>")
                        )
                    )
                )
                einnahmenaccounts
            )

            (printf "ust-summen<")
            (display ust-summen)
            (printf ">\n")

            (html-add-text doc "<br>")

            ;
            ; Zweiter schritt ist der vergleich mit den umsatzsteuer-konten:
            ;
            ; Schleife ueber die gefundenen ust saetze
            (hash-fold (lambda (ustsatz ust-value p)
                    (let (
                            ; (eurustkonto (get-eur-ust-konto ustsatz))
                            (eurustkonto (hash-ref ust-konten ustsatz))
                        )
                        (if eurustkonto
                            (let (
                                    ;(eurustsaldo (xaccAccountGetBalance eurustkonto))
                                    (eurustsaldo (gnc:account-get-balance-interval eurustkonto startdate enddate #f))
                                )

                                ; Gesamt summe verbuchte eingenommene ust fuer spaetere verprobung voranmeldungen
                                (set! summe-eurust (gnc-numeric-add-fixed summe-eurust eurustsaldo))

                                ; Verprobung berechnete eingenommene ust mit buchwert ust konto
                                (if (numeric-delta-compare eurustsaldo ust-value 1)
                                    (html-add-text doc
                                        "Einnahmen UST Verprobung fuer Konto '" (xaccAccountGetName eurustkonto) 
                                        "' (" (get-account-knr doc eurustkonto) ", " (num-account-comm-to-text eurustsaldo eurustkonto) ") " (greenText "OK") "<br>")
                                    (html-add-text doc
                                        "UST aus Einnahmen Konto " ustsatz "% : "
                                        (num-account-comm-to-text ust-value eurustkonto) " "
                                        " ist nicht gleich UST Saldo aus Konto " (xaccAccountGetName eurustkonto)
                                        "' (" (get-account-knr doc eurustkonto) "): " 
                                        (num-account-comm-to-text eurustsaldo eurustkonto) " "
                                        " " (redText "NOTOK") "<br>")
                                )
                            )
                            (html-add-text doc
                                "EUR - UST Konto fuer UST Satz " (number->string ustsatz) " % nicht gefunden "
                                (redText "NOTOK") "<br>")
                        )
                    )
            )
            #f ust-summen
            )
        )

        ;
        ; Ausgegebene Vorsteuer
        ;

        (html-add-text doc "<p><h4>Umsatzsteuer Verprobung:</h4></p>")

        ;
        ; Errechne je nach vorsteuersatz die vorsteuer aus den steuerpflichtigen ausgaben konten und vergleiche
        ; mit dem entsprechenden vorsteuer konto.
        ;
        (let (
                ; Alle steuerpflichtige ausgaben accounts (ausgaben, anlagen und maschinen)
                (ausgabenAccounts (find-accounts-has-desc-value doc "VSTK"))
                ; Speichert berechneten vorsteuer werte, key: vst value: summe-vst
                (vst-summen (make-hash-table 1))
                ; Speichert vst-konten, key: vst-satz value: konto
                (vst-konten (make-hash-table 1))
            )

            ;
            ; Im ersten schritt errechnen wir die VST aus netto-summe des kontos und dem enstprechenden
            ; VST-satz:
            ;
            (map (lambda (ausgabenKonto)
                    (let (
                            ; Vorsteuer satz des ausgaben kontos
                            (vstsatz (get-desc-numeric-value "VST" doc (get-gegenkonto-by-desc-value doc "VSTK" ausgabenKonto)))
                            (vstkonto (get-gegenkonto-by-desc-value doc "VSTK" ausgabenKonto))
                        )

                        (html-add-text doc "Konto " (xaccAccountGetName ausgabenKonto) " ...<br>")

                        ; Ausgaben konto ist vst maessig relevant
                        (if vstsatz
                            (let (
                                    ; Netto betrag des ausgaben kontos
                                    (ausgabenSaldo (gnc:account-get-balance-interval ausgabenKonto startdate enddate #f))
                                    (vstnumeric (double-to-gnc-numeric vstsatz 100 GNC-RND-ROUND))
                                    (vst-value #f)
                                )

                                ; Vst fuer ausgaben konto berechnen
                                (set! vst-value (gnc-numeric-mul ausgabenSaldo vstnumeric 100 GNC-RND-ROUND)) ; z.B. x * 16
                                (set! vst-value (gnc-numeric-div vst-value numeric100 100 GNC-RND-ROUND)) ; / 100

                                (set! vorsteuer (gnc-numeric-add-fixed vorsteuer vst-value))

                                ; aufsummieren
                                (hash-set-add-numeric vst-summen vstsatz vst-value)
                                (hash-set! vst-konten vstsatz vstkonto)
                            )
                            (html-add-text doc
                                "Fehler, vst-satz fuer konto " (xaccAccountGetName ausgabenKonto) " nicht gefunden! " (redText "NOTOK") "<br>")
                        )
                    )
                )
                ausgabenAccounts
            )

            (printf "vst-summen<")
            (display vst-summen)
            (printf ">\n")

            (html-add-text doc "<br>")

            ;
            ; Zweiter schritt ist der vergleich mit den umsatzsteuer-konten:
            ;
            ; Schleife ueber die gefundenen vst saetze
            (hash-fold (lambda (vstsatz vst-value p)
                    (let (
                            (vorsteuerKonto (hash-ref vst-konten vstsatz))
                        )
                        (if vorsteuerKonto
                            (let (
                                    (vorsteuerSaldo (gnc:account-get-balance-interval vorsteuerKonto startdate enddate #f))
                                )

                                ;; ; Gesamt summe verbuchte eingenommene ust fuer spaetere verprobung voranmeldungen
                                ;; (set! summe-eurust (gnc-numeric-add-fixed summe-eurust vorsteuerSaldo))

                                ; Verprobung berechnete vst mit buchwert vst konto
                                (if (numeric-delta-compare vorsteuerSaldo vst-value 1)
                                    (html-add-text doc
                                        "Ausgaben Vorsteuer Verprobung fuer Konto '" (xaccAccountGetName vorsteuerKonto) 
                                        "' (" (get-account-knr doc vorsteuerKonto) ", " (num-account-comm-to-text vorsteuerSaldo vorsteuerKonto) ") " (greenText "OK") "<br>")
                                    (html-add-text doc
                                        "Vorsteuer aus Ausgaben Konto " vstsatz "% : "
                                        (num-account-comm-to-text vst-value vorsteuerKonto) " "
                                        " ist nicht gleich VST Saldo aus Konto " (xaccAccountGetName vorsteuerKonto)
                                        "' (" (get-account-knr doc vorsteuerKonto) "): " 
                                        (num-account-comm-to-text vorsteuerSaldo vorsteuerKonto) " "
                                        " " (redText "NOTOK") "<br>")
                                )
                                (html-add-text doc "<br>")
                            )
                            (html-add-text doc
                                "EUR - VST Konto fuer VST Satz " (number->string vstsatz) " % nicht gefunden " (redText "NOTOK") "<br>")
                        )
                    )
            )
            #f vst-summen
            )
        )


        (html-add-text doc "<h4><p>XXX Umsatzsteuer nicht implementiert! XXX</p></h4>")
(if #f
(begin

        ; ust - vorsteuer = summe VA
        (let (
                ; euer - vorsteuer konto
                ;;;;;;;;;;;;;;;;;;;;;,(eurvorsteuerkonto (find-acc-in-childs-by-code (gnc-account-get-children root-account) "9998"))
                ;;;;;;;;;;;;;;;;  (eurvorsteuersaldo #f)
                ; euer - voranmeldungen konto
                ;;;;;;;;;;;;;;;;;;;;;,(eurvakonto (find-acc-in-childs-by-code (gnc-account-get-children root-account) "9996"))
                (eurvakonto (find-acc-by-code "9996"))
                (eurvasaldo #f)
                ; euer - voranmeldungen konto
                ;;;;;;;;;;;(eurvatestkonto (find-acc-in-childs-by-code (gnc-account-get-children root-account) "9992"))
                (eurvatestkonto (find-acc-by-code "9992"))
                (eurvatestsaldo #f)

                (ust-vorst-va numeric0)
                (ust-minus-vorst summe-eurust)
            )

            ;;;;;;;;;;;;;;;;  (set! eurvorsteuersaldo (xaccAccountGetBalance eurvorsteuerkonto))
            (set! eurvasaldo (xaccAccountGetBalance eurvakonto))
            (set! eurvatestsaldo (xaccAccountGetBalance eurvatestkonto))

            (set! eurvasaldo (gnc-numeric-add-fixed eurvasaldo eurvatestsaldo))
            (set! ust-minus-vorst (gnc-numeric-add-fixed ust-minus-vorst eurvorsteuersaldo))

            (set! ust-vorst-va (gnc-numeric-add-fixed ust-vorst-va eurvasaldo))
            (set! ust-vorst-va (gnc-numeric-add-fixed ust-vorst-va ust-minus-vorst))

            (if (= 0 (gnc-numeric-compare ust-minus-vorst (gnc-numeric-neg eurvasaldo)))
                (html-add-text doc "UST - Vorsteuer == Summe Voranmeldungen ist " (greenText "OK") "<br>")
                (begin
                    (html-add-text doc "UST - Vorsteuer == Summe Voranmeldungen ist " (redText "NOTOK") "<br><br>")

                    (html-add-text doc
                        "UST (" (num-account-comm-to-text summe-eurust  eurvorsteuerkonto)
                        ") - Vorsteuer (" (num-account-comm-to-text eurvorsteuersaldo eurvorsteuerkonto) ") " 
                        " = " (num-account-comm-to-text ust-minus-vorst eurvorsteuerkonto) " != "
                        "Summe VA (" (num-account-comm-to-text eurvasaldo eurvorsteuerkonto) ") ! <br><br>")

                    (html-add-text doc
                        "UST - Vorsteuer + Summe VA: " (num-account-comm-to-text ust-vorst-va eurvorsteuerkonto) "<br>")
                )
            )
        )

))

        ; Pruefe anzahl splits in transaktion (nur ein bruttosplit erlaubt)
        (let (
                 (query (qof-query-create-for-splits))
                 (splitsOk #t)
            )

            (html-add-text doc "<h4>Pruefe Anzahl Splits/Bruttowerte:</h4>")

            ; Select alle transaktionen
            (qof-query-set-book query (gnc-get-current-book))

            (map (lambda (trn)
                    (let (
                            (splits (xaccTransGetSplitList trn))
                        )
                        (if (> (length splits) 1)
                            (get-brutto-split doc trn)
                            (begin
                                (html-add-text doc "Buchung enth&auml;lt keinen oder nur einen split: ")
                                (html-add-trn doc trn)
                                (html-add-text doc "' " (redText "NOTOK") " <br>")
                                (set! splitsOk #f)
                            )
                        )
                    )
                )
                (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
            )

            (qof-query-destroy query)

            (if splitsOk
                (html-add-text doc (greenText "OK") "<br>")
            )
        )

        doc
    )
)

(define (add-ust-split doc trn ustsatz netto-value account)
    (let (
            ; Umsatzsteuer berechnen:
            (ust-value (get-ust-from-brutto netto-value ustsatz))
            (ust-split (xaccMallocSplit (gnc-get-current-book)))
            ;; (aktiva-accounts 
                ;; (gnc-account-get-descendants-sorted 
                    ;; (find-acc-in-childs-by-code (gnc:book-get-group (gnc:session-get-book  (gnc:get-current-session))) "4001")))
            (ust-account (get-gegenkonto-by-desc-value doc "USTK" account))
            (netto-split #f)
            (account-guid (gncAccountGetGUID account))
        )

        (printf "add-ust-split value<")
        (display ust-value)
        (printf ">\n")

        (html-add-text doc ", UST split wird angelegt...")

        ; Einnahmensplit suchen und aktualisieren
        (map (lambda (split)

                (if (string=? account-guid (gncAccountGetGUID (xaccSplitGetAccount split)))
                    (set! netto-split split)
                )
            )
            (xaccTransGetSplitList trn)
        )

        ; (set! split (xaccTransGetSplit last-afa-trn 0))
        ; (set! value-diff (gnc-numeric-sub-fixed (xaccSplitGetValue anl-split) afa-value-sum))
        ; (set! last-value (gnc-numeric-add-fixed last-value value-diff))

        ; Schleife ueber alle aktiva konten:
        ;; (for-each (lambda (ust-acc)
                ;; (if (= (get-ust-satz-from-account doc ust-acc) ustsatz)
                    ;; (set! ust-account ust-acc)
                ;; )
            ;; )
            ;; aktiva-accounts
        ;; )

        (printf "add-ust-split ust-account<")
        (display ust-account)
        (printf ">\n")

        ; Neuen UST split einfuegen
        (if ust-account
            (begin
                (xaccTransBeginEdit trn)

                (xaccSplitSetValue ust-split ust-value)
                (xaccSplitSetAmount ust-split ust-value)

                ; Identifizierung automatische UST buchungen
                (xaccSplitSetMemo ust-split  (string-append "UST " (number->string ustsatz) "%"))

                (xaccSplitSetAccount ust-split ust-account)
                (xaccSplitSetParent ust-split trn)

                (xaccSplitSetValue netto-split (gnc-numeric-sub-fixed netto-value ust-value))
                (xaccSplitSetAmount netto-split (gnc-numeric-sub-fixed netto-value ust-value))

                (xaccTransCommitEdit trn)
            )
            (html-add-text doc (redText "Fehler") ", UST Konto fuer " (number->string ustsatz) "% nicht gefunden !<br>")
        )
    )
)

(define (add-vorsteuer-split doc trn ustsatz netto-value account)
    (let (
            ; Umsatzsteuer berechnen:
            (ust-value (get-ust-from-brutto netto-value ustsatz))
            (ust-split (xaccMallocSplit (gnc-get-current-book)))
            ;; (aktiva-accounts 
                ;; (gnc-account-get-descendants-sorted 
                    ;; (find-acc-in-childs-by-code (gnc:book-get-group (gnc:session-get-book  (gnc:get-current-session))) "4001")))
            (ust-account (get-gegenkonto-by-desc-value doc "VSTK" account))
            (netto-split #f)
            (account-guid (gncAccountGetGUID account))
        )

        (printf "add-vorsteuer-split value<")
        (display ust-value)
        (printf ">\n")

        (html-add-text doc ", Vorsteuer split wird angelegt...")

        ; Einnahmensplit suchen und aktualisieren
        (map (lambda (split)

                (if (string=? account-guid (gncAccountGetGUID (xaccSplitGetAccount split)))
                    (set! netto-split split)
                )
            )
            (xaccTransGetSplitList trn)
        )

        ; (set! split (xaccTransGetSplit last-afa-trn 0))
        ; (set! value-diff (gnc-numeric-sub-fixed (xaccSplitGetValue anl-split) afa-value-sum))
        ; (set! last-value (gnc-numeric-add-fixed last-value value-diff))

        ; Schleife ueber alle aktiva konten:
        ;; (for-each (lambda (ust-acc)
                ;; (if (= (get-ust-satz-from-account doc ust-acc) ustsatz)
                    ;; (set! ust-account ust-acc)
                ;; )
            ;; )
            ;; aktiva-accounts
        ;; )

        (printf "add-vorsteuer-split ust-account<")
        (display ust-account)
        (printf ">\n")

        ; Neuen Vorsteuer split einfuegen
        (if ust-account
            (begin
                (xaccTransBeginEdit trn)

                (xaccSplitSetValue ust-split ust-value)
                (xaccSplitSetAmount ust-split ust-value)

                ; Identifizierung automatische UST buchungen
                (xaccSplitSetMemo ust-split  (string-append "Vorsteuer " (number->string ustsatz) "%"))

                (xaccSplitSetAccount ust-split ust-account)
                (xaccSplitSetParent ust-split trn)

                (xaccSplitSetValue netto-split (gnc-numeric-sub-fixed netto-value ust-value))
                (xaccSplitSetAmount netto-split (gnc-numeric-sub-fixed netto-value ust-value))

                (xaccTransCommitEdit trn)
            )
            (html-add-text doc (redText "Fehler") ", Vorsteuer Konto fuer " (number->string ustsatz) "% nicht gefunden !<br>")
        )
    )
)

; Findet alle accounts, die (oder deren eltern, im gegnsatz zu find-accounts-has-desc-value-no-descendants) ein bestimmten
; descvalue key besitzen.
(define (find-accounts-has-desc-value doc key)

    (let (
          (result '())
         )
        (for-each (lambda (account)
            (let (
                        (descval (get-desc-value key doc account #t))
                    )
                    ; (html-add-text doc "Konto " (xaccAccountGetCode account) " " (xaccAccountGetDescription account)  "val: " descval "<br>")
                    (if descval
                        ;  (set! result (append (cons account result) (gnc-account-get-descendants-sorted account)))
                        (set! result (append result (list account)))
                    )
                )
            )
            ; (gnc:group-get-subaccounts (gnc:get-current-group))
            (gnc-account-get-descendants-sorted (gnc-get-current-root-account))
        )
        result
    )
)

; Findet alle accounts (ohne kinder im gegensatz zu find-accounts-has-desc-value()),
; die ein bestimmten descvalue key besitzen.
(define (find-accounts-has-desc-value-no-descendants doc key)

    (let (
          (result '())
         )
        (for-each (lambda (account)
            (let (
                        (descval (get-desc-value key doc account #f))
                    )
                    ; (html-add-text doc "Konto " (xaccAccountGetCode account) " " (xaccAccountGetDescription account)  "val: " descval "<br>")
                    (if descval
                        ;  (set! result (append (cons account result) (gnc-account-get-descendants-sorted account)))
                        (set! result (append result (list account)))
                    )
                )
            )
            ; (gnc:group-get-subaccounts (gnc:get-current-group))
            (gnc-account-get-descendants-sorted (gnc-get-current-root-account))
        )
        result
    )
)

(define (report-get-option report-obj section name)
    (gnc:option-value (gnc:lookup-option (gnc:report-options report-obj) section name)))


(define (ustPruefung doc report-obj)

    (let (
            ; Alle steuerpflichtige einnahmen accounts
            (einnahmenaccounts (find-accounts-has-desc-value doc "USTK"))
            ; Alle steuerpflichtige ausgaben accounts
            (ausgabenaccounts (find-accounts-has-desc-value doc "VSTK"))

            (create-ust-splits (report-get-option report-obj gnc:pagename-general optname-enter-tax-splits))
            (begindate (gnc:timepair-start-day-time
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-from-date))))
            (enddate (gnc:timepair-end-day-time 
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-to-date))))
        )

        ; Hier wird sicherheitshalber die option zurueckgesetzt, dies wirkt sich leider nicht auf einen aktuell
        ; geoeffneten options-dialog aus. Erst nach schliessen und erneutem oeffnen wird die zurueckgesetzte option
        ; sichtbar.
        (gnc:option-set-value
               (gnc:lookup-option (gnc:report-options report-obj) gnc:pagename-general optname-enter-tax-splits) #f)

        (html-add-text doc "<h2>Ergebnis UST Pruefung:</h2>")

        ; Umsatzsteuer
        (html-add-text doc "<h4>Pruefung Umsatzsteuer</h4>")

        (html-add-text doc "Vom " (gnc-print-date begindate) " bis " (gnc-print-date enddate) "</p>")

        (if (null? einnahmenaccounts)
            (html-add-text doc "Keine Konten mit 'USTK' key gefunden.<p>")
        )

        ; Schleife ueber alle einnahmen konten:
        (for-each (lambda (account)
                (let (
                        (ustsatz (get-gegenkonto-desc-numeric-value doc "USTK" "UST" account))
                    )

                    (html-add-text doc (greenText "Konto") " '" (xaccAccountGetCode account) "' '" (xaccAccountGetDescription account)  "'<br>")

                    (if ustsatz
                        ; Einnahmen konto ist ust relevant
                        (let (
    	                        (query (qof-query-create-for-splits))
                            )
                            ; Alle buchungen im konto...
                            (qof-query-set-book query (gnc-get-current-book))
                            (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
                            (xaccQueryAddDateMatchTS query #t begindate #t enddate QOF-QUERY-AND)

                            (map (lambda (trn)
                                    (let (
                                            (netto-value #f)
                                            (ust-split-value numeric0)
                                        )

                                        ; (html-add-trn doc trn)
                                        ; (html-add-text doc "<br>")

                                        ; (display trn)
                                        ; (printf " <-trn\n")
                                        (printf "ust satz: ")
                                        (display ustsatz)
                                        (printf "\n")
                                        (map (lambda (split)
                                                (if (get-account-desc-numeric-value-from-split doc "UST" split)
                                                    (begin
                                                        (printf "ustsatz from split<")
                                                        (display (get-account-desc-numeric-value-from-split doc "UST" split))
                                                        (printf ">\n")
                                                        ; den ust - split der einnahme gefunden
                                                        ; ust satz checken
                                                        (if (not (= (get-account-desc-numeric-value-from-split doc "UST" split) ustsatz))
                                                            (begin
                                                                (html-add-text doc "Falsches UST konto in Transaktion '")
                                                                (html-add-trn doc trn)
                                                                (html-add-text doc "' " (redText "NOTOK") " <br>")
                                                            )
                                                        )
                                                        ; ggf. mehrere ust splits in trn aufsummieren
                                                        (set! ust-split-value (gnc-numeric-add-fixed ust-split-value (xaccSplitGetValue split)))
                                                    )
                                                )
                                            )
                                            (xaccTransGetSplitList trn)
                                        )
                                        (set! netto-value (xaccTransGetAccountValue trn account))

                                        (if (gnc-numeric-zero-p ust-split-value)
                                            (begin
                                                (html-add-text doc "UST split nicht in Transaktion '")
                                                (html-add-trn doc trn)
                                                (html-add-text doc "' gefunden " (redText "NOTOK"))
                                                (if create-ust-splits
                                                    (add-ust-split doc trn ustsatz netto-value account)
                                                )
                                                (html-add-text doc "<br>")
                                            )
                                            (let (
                                                    (ust-value (get-ust-from-netto netto-value ustsatz))
                                                )
                                                (if (not (numeric-delta-compare ust-split-value ust-value 0.01))
                                                    (begin
                                                        (printf "split-value: %s, ust satz: %d, ust-value: %s\n" (gnc-numeric-to-string ust-value) ustsatz (gnc-numeric-to-string ust-split-value))
                                                        (printf "berechnete ust: %s\n" (gnc-numeric-to-string ust-value))
                                                        (html-add-text doc "UST wert in Transaktion '") (html-add-trn doc trn)
                                                        (html-add-text doc "' stimmt nicht " (redText "NOTOK") "<br>")
                                                    )
                                                )
                                            )
                                        )
                                    )
                                )
                                (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
                            )
                            (qof-query-destroy query)
                        )
                        (html-add-text doc "Kein UST konto (USTK)/keinen UST Satz (UST) gefunden.<br>")
                    )
                )
            )
            einnahmenaccounts
        )

        ; Vorsteuer
        (html-add-text doc "<h4>Pruefung Vorsteuer</h4>")

        (if (null? ausgabenaccounts)
            (html-add-text doc "Keine Konten mit 'VSTK' key gefunden.<p>")
        )

        ; schleife ueber alle ausgaben konten:
        (for-each (lambda (account)
                (let (
                        (ustsatz (get-gegenkonto-desc-numeric-value doc "VSTK" "VST" account))
                    )

                    (html-add-text doc (greenText "Konto") " '" (xaccAccountGetCode account) "' '" (xaccAccountGetDescription account)  "'<br>")

                    ; xxx auch ausgabenkonten ohne ust pruefen
                    ; (if (> ustsatz 0)
                    (if ustsatz
                        ; ausgaben konto ist ust relevant
                        (let (
                                ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
                            )
                            

                            (qof-query-set-book query (gnc-get-current-book))
                            (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
                            (xaccQueryAddDateMatchTS query #t begindate #t enddate QOF-QUERY-AND)

                            (map (lambda (trn)
                                    (let (
                                            (netto-value #f)
                                            (ust-split-value numeric0)
                                        )

                                        ; (html-add-trn doc trn)
                                        ; (html-add-text doc "<br>")

                                        ; (display trn)
                                        ; (printf " <-trn\n")
                                        (map (lambda (split)
                                                (if (get-account-desc-numeric-value-from-split doc "VST" split)
                                                    (begin
                                                        ; den ust - split der ausgab gefunden
                                                        ; ust satz checken
                                                        (if (not (= (get-account-desc-numeric-value-from-split doc "VST" split) ustsatz))
                                                            (begin
                                                                (printf "vakonto falsch: ust satz1: %d, ustsatz2: %d\n" ustsatz (xxx-get-ust-satz-from-split doc split))
                                                                (html-add-text doc "Falsches Vorsteuer konto in Transaktion '")
                                                                (html-add-trn doc trn)
                                                                (html-add-text doc "' " (redText "NOTOK") " <br>")
                                                            )
                                                        )
                                                        ; ggf. mehrere ust splits in trn aufsummieren
                                                        (set! ust-split-value (gnc-numeric-add-fixed ust-split-value (xaccSplitGetValue split)))
                                                    )
                                                )
                                            )
                                            (xaccTransGetSplitList trn)
                                        )
                                        (set! netto-value (xaccTransGetAccountValue trn account))

                                        ; xxx auch ausgabenkonten ohne ust pruefen
                                        (if (and (gnc-numeric-zero-p ust-split-value) (not (= ustsatz 0)))
                                            (begin
                                                (html-add-text doc "Vorsteuer split nicht in Transaktion '")
                                                (html-add-trn doc trn)
                                                (html-add-text doc "' gefunden " (redText "NOTOK"))
                                                (if create-ust-splits
                                                    (add-vorsteuer-split doc trn ustsatz netto-value account)
                                                )
                                                (html-add-text doc "<br>")
                                            )
                                            (let (
                                                    (ust-value (get-ust-from-netto netto-value ustsatz))
                                                )
                                                (if (not (numeric-delta-compare ust-split-value ust-value 0.01))
                                                    (begin
                                                        (printf "split-value: %s, ust satz: %d, ust-value: %s\n" (gnc-numeric-to-string ust-value) ustsatz (gnc-numeric-to-string ust-split-value))
                                                        (printf "berechnete ust: %s\n" (gnc-numeric-to-string ust-value))
                                                        (html-add-text doc "Vorsteuer wert in Transaktion '") (html-add-trn doc trn)
                                                        (html-add-text doc "' stimmt nicht " (redText "NOTOK") "<br>")
                                                    )
                                                )
                                            )
                                        )
                                    )
                                )
                                (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
                            )
                            (qof-query-destroy query)
                        )
                        (html-add-text doc "Kein Vorsteuer konto (VSTK)/keinen Vorsteuer Satz (VST) gefunden.<br>")
                    ) ; if (>= ustsatz 0)

                )
            )
            ausgabenaccounts
        )

        doc
    )
)

(define (ustRenderer report-obj)
    (let (
            (doc (gnc:make-html-document))
        )

        (and (jahrBuchCheck doc) (ustPruefung doc report-obj))
        doc
    )
)

(define (gnc-book-path name)    
    (build-path (getenv "HOME") "gncdata" name)
)


;;;;; ; Hack for missing gnc-get-current-session:
;;;;; (define my-current-session #f)
;;;;; (define (my-book-opened-hook session)
  ;;;;; (begin
    ;;;;; (printf "my-book-opened-hook called\n")
    ;;;;; (set! my-current-session session)
  ;;;;; )
;;;;; )
;;;;; (define (my-book-closed-hook session)
  ;;;;; (begin
    ;;;;; (printf "my-book-closed-hook called\n")
    ;;;;; (set! my-current-session #f)
  ;;;;; )
;;;;; )
;;;;; (gnc-hook-add-scm-dangler "hook_book_opened" my-book-opened-hook)
;;;;; (gnc-hook-add-scm-dangler "hook_book_closed" my-book-closed-hook)
; End hack

; (define (afa-book-opened)
    ; (let (
        ; ; (splitted (string-split (qof-session-get-url (gnc-get-current-session)) #\/))
        ; (splitted (string-split (qof-session-get-url my-current-session) #\/))
        ; )
; ; 
        ; ; (or
            ; ; (string=? (gnc-book-path "abschreibungen.gnc") (qof-session-get-url (gnc:get-current-session)))
            ; ; (string=? (gnc-book-path "afatest.gnc") (qof-session-get-url (gnc:get-current-session)))
        ; ; )
        ; (or
            ; (string=? (list-ref splitted (- (length splitted) 1)) "abschreibungen.gnc")
            ; (string=? (list-ref splitted (- (length splitted) 1)) "afatest.gnc")
        ; )
    ; )
; )

(define (afa-book-opened doc)
    (not (null? (find-accounts-has-desc-value doc "AFABUCH")))
)

(define (afa-desc str trn)
    (string-append str " " (xaccTransGetDescription trn))
)

; Betrag abschreibung, wert/ndauer
(define (compute-afa-value anl-split ndauer)
    (let (
            (nd (double-to-gnc-numeric ndauer 100 GNC-RND-ROUND))
        )
        ; (gnc-numeric-div (xaccSplitGetValue anl-split) nd 100 GNC-RND-ROUND)
        (gnc-numeric-div (xaccSplitGetValue anl-split) nd GNC-DENOM-AUTO (logior GNC-DENOM-FIXED GNC-RND-ROUND))
    )
)

; Eine afa transaktion einfuegen
(define (afa-vorbereitung-add-trn accgroup trn anl-split afa-date afa-value i)
    (let (
            (afa-trn (xaccMallocTransaction (gnc-get-current-book)))
            (sa-split (xaccMallocSplit (gnc-get-current-book)))
            (afa-split (xaccMallocSplit (gnc-get-current-book)))
            (afa-account (find-acc-in-childs-by-code accgroup (get-afa-account-knr doc (xaccSplitGetAccount anl-split))))
        )
        (xaccTransBeginEdit afa-trn)


        ; waehrung
        (xaccTransSetCurrency afa-trn (xaccTransGetCurrency trn))

        ; 1. teilbuchung verringerung anlagen konto
        (xaccSplitSetValue sa-split (gnc-numeric-neg afa-value))
        (xaccSplitSetAmount sa-split (gnc-numeric-neg afa-value))

        (xaccSplitSetAccount sa-split (xaccSplitGetAccount anl-split))
        (xaccSplitSetParent sa-split afa-trn)

        ; 2. teilbuchung erhoehung afa konto
        (xaccSplitSetValue afa-split afa-value)
        (xaccSplitSetAmount afa-split afa-value)
        ; identifizierung automatische afa buchungen
        (xaccSplitSetMemo afa-split (string-append "AFA-NR " (xaccTransGetNum trn)))

        (xaccSplitSetAccount afa-split afa-account)
        (xaccSplitSetParent afa-split afa-trn)

        (xaccTransSetDatePostedTS afa-trn (gnc:date->timepair afa-date))
        (xaccTransSetDateEnteredTS afa-trn (gnc:date->timepair afa-date))
        (xaccTransSetDescription afa-trn (afa-desc (string-append "AFA " (number->string i)) trn))
        (xaccTransSetNum afa-trn (xaccTransGetNum trn))

        (xaccTransCommitEdit afa-trn)
        afa-trn ; return 
    )
)

; Eine transaktion fuer jedes jahr der abschreibungsdauer in das abschreibungskonto eintragen,
; kauf im zweiten halbjahr beruecksichtigen
(define (afa-vorbereitung-afa trn anl-split ndauer)
    (printf "afa-vorbereitung-afa called\n")
    (let (
            (kauf-datum (gnc-transaction-get-date-posted trn))
            (afa-datum (gnc:timepair->date (gnc-transaction-get-date-posted trn)))
            (normal-afa-value (compute-afa-value anl-split ndauer))
            (first-afa-value #f)
            ; (afa-value-sum #f)
            ; erinnerungswert
            (afa-value-sum numeric1)
            (last-afa-trn #f)
            (split #f)
            (last-value #f)
            (value-diff #f)
            (accgroup (gnc:book-get-group (gnc-get-current-book)))
        )
        (gnc:warn "kauf-datum" (gnc:timepair->date kauf-datum))
        (gnc:warn "anlage betrag: " (xaccSplitGetValue anl-split))
        (gnc:warn "afa betrag: " normal-afa-value)
        (if (> (gnc:timepair-get-month kauf-datum) 6) ; kauf im 2. halbjahr ?
            (begin
                (set! first-afa-value (compute-afa-value anl-split (* 2 ndauer))) ; halbe afa
            )
            (set! first-afa-value normal-afa-value)
        )

        ; erste abschreibung am 31.12 des kauf jahres:
        (set-tm:mon afa-datum 11) ; 11 -> dezember
        (set-tm:mday afa-datum 31)
        (set-tm:isdst afa-datum -1)

        (gnc:warn "first afa betrag: " first-afa-value)
        (afa-vorbereitung-add-trn accgroup trn anl-split afa-datum first-afa-value 1)
        ; (set! afa-value-sum first-afa-value)
        (set! afa-value-sum (gnc-numeric-add-fixed afa-value-sum first-afa-value))

        (do ( (i 1 (+ i 1)) )
            ((= i ndauer))
            (set-tm:year afa-datum (+ (tm:year afa-datum) 1))
            (set! last-afa-trn (afa-vorbereitung-add-trn accgroup trn anl-split afa-datum normal-afa-value (+ i 1)))
            (set! afa-value-sum (gnc-numeric-add-fixed afa-value-sum normal-afa-value))
            (set! last-value normal-afa-value)
        )

        (set-tm:year afa-datum (+ (tm:year afa-datum) 1))
        (if (> (gnc:timepair-get-month kauf-datum) 6) ; kauf im 2. halbjahr ?
            (begin
                (set! last-afa-trn (afa-vorbereitung-add-trn accgroup trn anl-split afa-datum first-afa-value (+ ndauer 1)))
                (set! afa-value-sum (gnc-numeric-add-fixed afa-value-sum first-afa-value))
                (set! last-value first-afa-value)
            )
        )

        (gnc:warn "first afa betrag: " first-afa-value)

        ; rundungsfehler vermeiden, erinnerungswert beibehalten:
        (xaccTransBeginEdit last-afa-trn)

        (set! split (xaccTransGetSplit last-afa-trn 0))

        (set! value-diff (gnc-numeric-sub-fixed (xaccSplitGetValue anl-split) afa-value-sum))

        (set! last-value (gnc-numeric-add-fixed last-value value-diff))

        (xaccSplitSetValue split last-value)
        (xaccSplitSetAmount split last-value)

        (set! split (xaccTransGetSplit last-afa-trn 1))

        (set! last-value (gnc-numeric-neg last-value))

        (xaccSplitSetValue split last-value)
        (xaccSplitSetAmount split last-value)

        (xaccTransCommitEdit last-afa-trn)

        ; Abgangs buchung 
        (let (
                (abg-trn (xaccMallocTransaction (gnc-get-current-book)))
                (sa-split (xaccMallocSplit (gnc-get-current-book)))
                (source-split (xaccMallocSplit (gnc-get-current-book)))
                (source-account (find-acc-in-childs-by-code accgroup (get-anf-account-knr doc (xaccSplitGetAccount anl-split))))
                (date (get-timepair-at-date 0 0 0 1 1 2038))
            )

            (xaccTransBeginEdit abg-trn)

            ; waehrung
            (xaccTransSetCurrency abg-trn (xaccTransGetCurrency trn))

            ; 1. teilbuchung verringerung anlagen konto
            (xaccSplitSetValue sa-split (gnc-numeric-neg numeric1))
            (xaccSplitSetAmount sa-split (gnc-numeric-neg numeric1))

            (xaccSplitSetAccount sa-split (xaccSplitGetAccount anl-split))
            (xaccSplitSetParent sa-split abg-trn)

            ; 2. teilbuchung erhoehung afa konto
            (xaccSplitSetValue source-split numeric1)
            (xaccSplitSetAmount source-split numeric1)
            ; identifizierung automatische afa buchungen
            (xaccSplitSetMemo source-split  (string-append "ABG-NR " (xaccTransGetNum trn)))

            (xaccSplitSetAccount source-split source-account)
            (xaccSplitSetParent source-split abg-trn)

            (xaccTransSetDatePostedTS abg-trn date)
            (xaccTransSetDateEnteredTS abg-trn date)
            (xaccTransSetDescription abg-trn (afa-desc "Abg./Verkauf" trn))
            (xaccTransSetNum abg-trn (xaccTransGetNum trn))

            (xaccTransCommitEdit abg-trn)
        )
    )
)

(define (get-list-kvp lst key indx)

    (if (>= indx (length lst))
        #f
        (if (string=? (list-ref lst indx) key)
            (list-ref lst (+ indx 1))
            (get-list-kvp lst key (+ indx 2))
        )
    )
)

; Holt pseudo kvp's aus string
(define (get-pseudo-kvp str key) 
    (let (
            (splitted (string-split str #\ ))
        )
        (get-list-kvp splitted key 0)
    )
)

; afa - transaktionen fuer eine anlage erzeugen/aktualisieren
(define (afa-vorbereitung-trn doc trn anl-split)
    (printf "afa-vorbereitung-trn\n")

    (html-add-text doc "<p>Abschreibungen fuer '" (xaccTransGetDescription trn) "' ")
    (html-add-trn doc trn)
    (html-add-text doc "... </p>")

    (let (
            ; Speicherung abschreibungsdauer in slot-memo, fuer spaeteren anlagen 
            ; spiegel report
            (ndauer-string (get-pseudo-kvp (xaccSplitGetMemo anl-split) "ND"))
        )

        (if ndauer-string
            (begin
                (html-add-text doc " ... nicht vorhanden, erzeuge Transaktionen ...<br>")
                (afa-vorbereitung-afa trn anl-split (string->number ndauer-string))
            )
            (html-add-text doc "Nutzungsdauer nicht eingetragen (Key 'ND' im Memo fehlt)<br>")
        )
    )
)

; Afa buchungen im afa buch vorbereiten
(define (afavRenderer report-obj)
    (let (
            (doc (gnc:make-html-document))
        )

        (html-add-text doc "<h2>Ergebnis AFA Vorbereitung:</h2>")

        ; nur im afa buch moeglich ...
        (if (afaBuchCheck doc) 
            (let (
                    (anlagenaccounts (get-anlagen-konten))
                )

                ; schleife ueber alle anlagen konten
                (for-each (lambda (anlagenaccount)
                        (let (
                            ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
                            ; liste aller gefundenen anlagen
                            (anlagen '())
                            ; hash mit allen afa und abgangs buchungen
                            (afabuchungen (make-hash-table 1))
                            )

                            (html-add-text doc "<h3>Konto '" (xaccAccountGetName anlagenaccount) "' ("
                                (get-account-knr doc anlagenaccount) ")</h2>")

                            (qof-query-set-book query (gnc-get-current-book))
                            (xaccQueryAddSingleAccountMatch query anlagenaccount QOF-QUERY-AND)
                            (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())

                            
                            ; schleife ueber alle splits aus dem anlagevermoegen konto, suche die anlagen splits
                            ;;;;;;;;;;;;   - kein IBRAfaId
                            ;;;;;;;;;;;;   - kein IBRAnlageAbgangId
                            ; Key "AFA-ID"
                            (map (lambda (split)

                                    (let (
                                            (trn (xaccSplitGetParent split))
                                            (afa-nr (get-pseudo-kvp (xaccSplitGetMemo split) "AFA-NR"))
                                            (abg-nr (get-pseudo-kvp (xaccSplitGetMemo split) "ABG-NR"))
                                        )

                                        (if (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")
                                            ; anlage
                                            (set! anlagen (append anlagen (list split)))
                                        )

                                        (if afa-nr
                                            ; afa buchung
                                            (hash-set! afabuchungen afa-nr trn)
                                        )

                                        (if abg-nr
                                            ; abgangs buchung
                                            (hash-set! afabuchungen abg-nr trn)
                                        )
                                    )

                                )
                                (xaccQueryGetSplitsUniqueTrans query)
                            )

                            (qof-query-destroy query)

                            ; sortierte liste der anlagen abarbeiten, afa buchungen nur erzeugen, falls noch keine 
                            ; vorhanden
                            (map (lambda (split)
                                    (let (
                                            (trn (xaccSplitGetParent split))
                                        )
                                        (if (hash-ref afabuchungen (xaccTransGetNum trn))
                                            (begin
                                                (html-add-text doc "<p>Buchungen fuer '" (xaccTransGetDescription trn) "' ")
                                                (html-add-trn doc trn)
                                                (html-add-text doc " bereits vorhanden <br>")
                                            )
                                            (afa-vorbereitung-trn doc trn split)
                                        )
                                    )
                                )
                                anlagen
                            )
                        )
                    )
                    anlagenaccounts
                )

            )
        )

        doc
    )
)

; Konvertiere kvp-values in split-kommentare
(define (usttestRenderer report-obj)
    (let (
            (accgroup (gnc:book-get-group (gnc-get-current-book)))
            (doc (gnc:make-html-document))
        )

        (html-add-text doc "<h2>Ergebnis usttest")

        (html-add-text doc "tax code:")
        (html-add-text doc (xaccAccountGetTaxUSCode (find-acc-in-childs-by-code accgroup "1800")))

        doc
    )
)

; Kontonummer zielkonto im aktuellen jahrbuch aus kontonummer im afa-buch extrahieren
(define (get-ziel-buch-konto anlagen-knr)
    (list-ref (string-split (list-ref (string-split anlagen-knr #\|) 0) #\-) 0)
)

; Vergleich zweier waehrungen, es gibt zwar die funktion gnc:commodity-equiv? 
; aber es ist nicht klar wie diese sich verhaelt wenn die beiden waehrungen aus verschiedenen
; buechern stammen. Desshalb vergleich ueber Waehrungskurzname.
(define (waehrungs-vergleich ca cb)
    ; (printf "waehrung a: '%s', b: '%s'\n" (gnc-commodity-get-mnemonic ca) (gnc-commodity-get-mnemonic cb))
    (string=? (gnc-commodity-get-mnemonic ca) (gnc-commodity-get-mnemonic cb))
)

; gnc:is-euro-currency geht nicht !?
(define (ist-euro-waehrung c)
    ; (printf "waehrung: '%s'\n" (gnc-commodity-get-mnemonic c))
    (string=? (gnc-commodity-get-mnemonic c) "EUR")
)

(define (copy-afa-trn doc trn)
    (let (
            ;; (new-trn (copy-trn-prepare doc trn kvpkeyname kvpvalue))
            ; (accgroup (gnc:book-get-group (gnc-get-current-book)))
            (new-trn (xaccMallocTransaction (gnc-get-current-book)))
        )

        (html-add-text doc "Copying afa transaction ...<br>")

        (xaccTransBeginEdit new-trn)

        ; die einzelnen splits kopieren
        (map (lambda (split)
                (let (
                        (new-split (xaccMallocSplit (gnc-get-current-book)))
                        ; account aus anderem buch!
                        ; (account (find-acc-in-childs-by-code accgroup (get-ziel-buch-konto (xxx-get-split-knr doc split))))
                        (account (find-acc-by-code (get-ziel-buch-konto (xxx-get-split-knr doc split))))
                    )
                    (if account
                        (let (
                                (jb-comm (xaccAccountGetCommodity account))
                                ;;;;;;;;;;;;;;;;;;(ab-comm (xaccAccountGetCommodity (xaccSplitGetAccount split)))
                                (value (xaccSplitGetValue split))
                            )

                            ; waehrung, kommt aus anderem buch 
                            (xaccTransSetCurrency new-trn jb-comm)

                            ;;;;;;;;;;;;;;;;;;(if (not (waehrungs-vergleich ab-comm jb-comm))
                                ;;;;;;;;;;;;;;;;;;(if (ist-euro-waehrung ab-comm)
                                    ;;;;;;;;;;;;;;;;;;(html-add-text doc (redText "ERROR") ", umrechnung von EUR in DM !, Zielkonto: " 
                                        ;;;;;;;;;;;;;;;;;;(xaccAccountGetName account) "' (" (get-account-knr doc account) ") <br>")
                                    ;;;;;;;;;;;;;;;;;;; umrechnung DM -> EUR
                                    ;;;;;;;;;;;;;;;;;;(set! value (gnc-convert-to-euro ab-comm value))
                                ;;;;;;;;;;;;;;;;;;)
                            ;;;;;;;;;;;;;;;;;;)

                            (set! value (comm-umrechnung doc (xaccSplitGetAccount split) value jb-comm))

                            (xaccSplitSetValue new-split value)
                            (xaccSplitSetMemo new-split (xaccSplitGetMemo split))
                            (xaccSplitSetAmount new-split value)
                            (xaccSplitSetAccount new-split account)
                            (xaccSplitSetParent new-split new-trn)
                        )
                        (html-add-text doc "Zielkonto " (get-ziel-buch-konto (xxx-get-split-knr doc split)) " nicht gefunden !<br>")
                    )
                )
            )
            (xaccTransGetSplitList trn)
        )

        (xaccTransSetNum new-trn (xaccTransGetNum trn))
        (xaccTransSetDatePostedTS new-trn (xaccTransGetDatePostedTS trn))
        (xaccTransSetDateEnteredTS new-trn (xaccTransGetDateEnteredTS trn))
        (xaccTransSetDescription new-trn (xaccTransGetDescription trn))
        (xaccTransCommitEdit new-trn)
    )
)

(define (copy-afa-eroeffnung doc trn ab-anlagen-account value thisyear anl-split)
    (let (
            (new-trn (xaccMallocTransaction (gnc-get-current-book)))

            ; (accgroup (gnc:book-get-group (gnc-get-current-book)))
            (anf-account #f)
            (anl-account #f)
            (anlagenaccountknr (get-ziel-buch-konto (get-account-knr doc ab-anlagen-account)))
            ; waehrung im afa buch
            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;; (ab-comm (xaccAccountGetCommodity ab-anlagen-account))
        )

        (html-add-text doc "Copying afa eroeffnung ...<br>")

        ; (set! anf-account (find-acc-in-childs-by-code accgroup "9000"))
        ; (set! anl-account (find-acc-in-childs-by-code accgroup anlagenaccountknr))
        (set! anf-account (find-acc-by-code "9000"))
        (set! anl-account (find-acc-by-code anlagenaccountknr))

        (xaccTransBeginEdit new-trn)
        (xaccTransSetNum new-trn (xaccTransGetNum trn))

        (if (and anf-account anl-account)
            (let (
                    ; waehrung im jahrgangs buch
                    (jb-comm (xaccAccountGetCommodity anl-account))
                    (sa-split (xaccMallocSplit (gnc-get-current-book)))
                    (anf-split (xaccMallocSplit (gnc-get-current-book)))
                    (date (get-timepair-at-date 0 0 0 1 1 thisyear))
                )

                (if (= 0 (gnc-numeric-compare value numeric1))
                    (xaccTransSetDescription new-trn (afa-desc "Erinn. Wert" trn))
                    (xaccTransSetDescription new-trn (afa-desc "Eroeffnung" trn))
                )

                ; waehrung
                (xaccTransSetCurrency new-trn jb-comm)

                ;;;;;;;;;;;;;;;;;;,,,,(if (not (waehrungs-vergleich ab-comm jb-comm))
                    ;;;;;;;;;;;;;;;;;;,,,,(if (ist-euro-waehrung ab-comm)
                        ;;;;;;;;;;;;;;;;;;,,,,(html-add-text doc (redText "ERROR") ", umrechnung von EUR in DM !, Zielkonto: " 
                            ;;;;;;;;;;;;;;;;;;,,,,(xaccAccountGetName anl-account) "' (" (get-account-knr doc anl-account) ") <br>")
                        ;;;;;;;;;;;;;;;;;;,,,,; umrechnung DM -> EUR
                        ;;;;;;;;;;;;;;;;;;,,,,(set! value (gnc-convert-to-euro ab-comm value))
                    ;;;;;;;;;;;;;;;;;;,,,,)
                ;;;;;;;;;;;;;;;;;;,,,,)

                (set! value (comm-umrechnung doc ab-anlagen-account value jb-comm))

                ; 1. teilbuchung anlagen konto
                (xaccSplitSetValue sa-split value)
                (xaccSplitSetAmount sa-split value)
                (xaccSplitSetMemo sa-split (xaccSplitGetMemo anl-split))

                (xaccSplitSetAccount sa-split anl-account)
                (xaccSplitSetParent sa-split new-trn)

                ; 2. teilbuchung anfangsbestand konto
                (xaccSplitSetValue anf-split (gnc-numeric-neg value))
                (xaccSplitSetAmount anf-split (gnc-numeric-neg value))

                (xaccSplitSetAccount anf-split anf-account)
                (xaccSplitSetParent anf-split new-trn)

                (xaccTransSetDatePostedSecs new-trn (gnc:timepair->secs date))
                (xaccTransSetDateEnteredSecs new-trn (gnc:timepair->secs date))
            )
            (html-add-text doc "Konto 9000 oder Konto " anlagenaccountknr " nicht gefunden !<br>")
        )
        (xaccTransCommitEdit new-trn)
    )
)

; liefert timepair fuer bestimmtes datum fuer query/transaktions datum
(define (get-timepair-at-date sec minu hr day mon year)
    (let (
            (date (localtime (current-time)))
        )
        (set-tm:sec date sec)
        (set-tm:min date minu)
        (set-tm:hour date hr)
        (set-tm:mday date day)
        (set-tm:mon date (- mon 1))
        (set-tm:year date (- year 1900))
        (set-tm:isdst date -1)
        (gnc:date->timepair date)
    )
)

(define (get-afa-split-id split-memo)

    (or (get-pseudo-kvp split-memo "ANL-NR") (get-pseudo-kvp split-memo "ERW-NR") (get-pseudo-kvp split-memo "AFA-NR") (get-pseudo-kvp split-memo "ABG-NR"))
)

; alle split memo's nach id's durchsuchen
(define (is-afa-buchung trn)
    (let (
            (result #f)
            ; (slots (gnc-transaction-get-slots trn))
        )

        ; (if (or (gnc:kvp-frame-get-slot slots "IBRAfaId") (gnc:kvp-frame-get-slot slots "IBRAnlageAbgangId") (gnc:kvp-frame-get-slot slots "IBRAnlageId") (gnc:kvp-frame-get-slot slots "IBRAnlageNDauer"))
            ; (set! result #t)
        ; )

        (map (lambda (split)
                (if (get-afa-split-id (xaccSplitGetMemo split))
                    (set! result #t)
                )
            )
            (xaccTransGetSplitList trn)
        )

        result
    )
)

(define (delete-afa-buchungen)
    (let (
            (anlagenaccounts (get-anlagen-konten-gwg (gnc-get-current-book)))
            ; (query (gnc:malloc-query))
             (query (qof-query-create-for-splits))
        )

        (qof-query-set-book query (gnc-get-current-book))
        (xaccQueryAddAccountMatch query anlagenaccounts QOF-GUID-MATCH-ANY QOF-QUERY-AND)

        (map (lambda (trn)

                (if (is-afa-buchung trn)
                    (begin
                        (printf "found transaction, deleting ...\n")
                        (xaccTransBeginEdit trn)
                        (xaccTransDestroy trn)
                        (xaccTransCommitEdit trn)
                    )
                )

            )
            (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
        )

        (qof-query-destroy query)
    )
)

; transaktionen in account bis zum jahresende von thisyear suchen
(define (query-trn-by-account-and-endyear session account year)
    (let ( 
            ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
            (trnlist #f)
            ; 31.12.year
            (enddate (get-timepair-at-date 59 59 23 31 12 year))
        )

        ; (printf "year %d\n" year)
        (qof-query-set-book query (qof-session-get-book session))
        (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
        ; (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())
        ; (qof-query-set-sort-order query (list gnc:split-trans gnc-trans-date-posted) '() '())
        ; (gnc:query-add-date-match-timepair query 
            ; #f enddate
            ; #t enddate QOF-QUERY-AND)
        (xaccQueryAddDateMatchTS query
             #f enddate
             #t enddate QOF-QUERY-AND)

        (set! trnlist (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY))
        (qof-query-destroy query)

        trnlist
    )
)

; sortiere splits in account bis zum jahresende von thisyear suchen
(define (query-split-by-account-and-endyear session account year)
    (let ( 
            ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
            (splitlist #f)
            ; 31.12.year
            (enddate (get-timepair-at-date 59 59 23 31 12 year))
        )

        ; (printf "year %d\n" year)
        (qof-query-set-book query (qof-session-get-book session))
        (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
        (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())
        (gnc:query-add-date-match-timepair query 
            #f enddate
            #t enddate QOF-QUERY-AND)

        (set! splitlist (xaccQueryGetSplitsUniqueTrans query))
        (qof-query-destroy query)

        splitlist
    )
)

; xxx remove:
; sortiere splits in account bis zum jahresende von thisyear suchen
(define (query-split-by-account-and-endyear-all session account year)
    (let ( 
            ; (query (gnc:malloc-query))
            (query (qof-query-create-for-splits))
            (splitlist #f)
            ; 31.12.year
            (enddate (get-timepair-at-date 59 59 23 31 12 year))
        )

        ; (printf "year %d\n" year)
        (qof-query-set-book query (qof-session-get-book session))
        (xaccQueryAddSingleAccountMatch query account QOF-QUERY-AND)
        (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())
        ; (gnc:query-add-date-match-timepair query 
            ; #f enddate
            ; #t enddate QOF-QUERY-AND)
        (xaccQueryAddDateMatchTS query
             #f enddate
             #t enddate QOF-QUERY-AND)

        ; (set! splitlist (gnc:query-get-splits query))
        (set! splitlist (xaccQueryGetSplitsUniqueTrans query))
        (qof-query-destroy query)

        splitlist
    )
)

; Sortiere splits in account bis zum endedatume suchen
(define (query-split-by-account-and-enddate-all book root enddate)
    (let ( 
            ; (query (gnc:malloc-query))
            (query (qof-query-create-for-splits))
            (splitlist #f)
            (accounts (gnc-account-get-descendants-sorted root))
        )

        ; (printf "year %d\n" year)
        (qof-query-set-book query book)
        (if (null? accounts)
            (xaccQueryAddSingleAccountMatch query root QOF-QUERY-AND)
            (xaccQueryAddAccountMatch query accounts QOF-GUID-MATCH-ANY QOF-QUERY-AND)
        )
        (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())
        ; (gnc:query-add-date-match-timepair query 
            ; #f enddate
            ; #t enddate QOF-QUERY-AND)
        (xaccQueryAddDateMatchTS query
             #f enddate
             #t enddate QOF-QUERY-AND)

        ; (set! splitlist (gnc:query-get-splits query))
        (set! splitlist (xaccQueryGetSplitsUniqueTrans query))
        (qof-query-destroy query)

        splitlist
    )
)

; (define (berechne-afa-restwerte thisyear afa-book-session anlagenaccount)
(define (berechne-afa-restwerte enddate book anlagenaccount)
    (let (
            ; fuer restwerte sind nur buchungen aus vorjahren zu beruecksichtigen
            ; (splits (query-split-by-account-and-endyear-all afa-book-session anlagenaccount (- thisyear 1)))
            (splits (query-split-by-account-and-enddate-all book anlagenaccount enddate))
            ; key: anl-id value: restwert
            (restwerte (make-hash-table 1))
        )

        ; schleife ueber alle splits im aktuellen anlagevermoegen konto bis ende dieses jahr,
        ; restwerte aufsummieren
        (map (lambda (split)
                (let (
                        (id (get-afa-split-id (xaccSplitGetMemo split)))
                    )

                    (if id
                        ; den afa - split mit dem netto einkaufswert oder dem afawert oder dem
                        ; netto abgangswert der anlage gefunden
                        (hash-set-add-numeric restwerte id (xaccSplitGetValue split))
                    )
                )
            )
            splits
        )

        ;(gnc:warn "restwerte" restwerte)

        restwerte
    )
)

(define (afauRenderer report-obj)
    (let (
            (doc (gnc:make-html-document))
        )

        (html-add-text doc "<h2>Ergebnis AFA Uebernahme:</h2>")

        ; nicht im afa buch moeglich ...
        (if (jahrBuchCheck doc) 

            (let (
                    (afa-book-session (openSession (gnc-book-path "abschreibungen.gnc")))
                    ; (afa-book-session (openSession (gnc-book-path "afatest.gnc")))
                    (thisyear (get-this-year (gnc-get-current-book)))
                )

                (printf "thisyear: %d\n" thisyear)

                (if afa-book-session
                    (let (
                            (ab-anlagenaccounts (get-anlagen-konten-gwg (qof-session-get-book afa-book-session)))
                        )

                        ; Loesche alle buchungen in den anlagenkonten und im aktuellen jahrgang die einen
                        ; afa - key enthalten.
                        (delete-afa-buchungen)

                        ; schleife ueber alle anlagen accounts
                        (for-each (lambda (ab-anlagenaccount)
                                (let (
                                        (restwerte (berechne-afa-restwerte thisyear afa-book-session ab-anlagenaccount))
                                        (trnlist (query-trn-by-account-and-endyear afa-book-session ab-anlagenaccount thisyear))
                                    )

                                    (html-add-text doc "<h3>Konto: '" (xaccAccountGetName ab-anlagenaccount) "' " (get-account-knr doc ab-anlagenaccount) "</h3>")

                                    ; Schleife ueber alle transaktionen im aktuellen anlagevermoegen konto in diesem jahr,
                                    ; buchungen kopieren
                                    ; Die erweiterungsbuchungen (Key ERW-NR), afa buchungen (key AFA-NR) und die abgangsbuchungen (ABG-NR) 
                                    ; sind einfach, diese koennen 1:1 uebernommen werden, fall a
                                    ; Bei den eroeffnungsbuchungen siehts so aus:
                                    ;   - Kauf in diesem jahr: eroeffnungsbuchung kopieren, fall b
                                    ;   - Kauf vor diesem jahr:
                                    ;     - restwert > 0: eroeffnungs buchung mit restwert (erinnerungswert), fall c
                                    ;     - restwert = 0: keine eroeffnungs buchung fall d
                                    (map (lambda (trn)

                                            (let (
                                                    ; (afa-kvp-value (gnc:kvp-frame-get-slot (gnc-transaction-get-slots trn) "IBRAfaId"))
                                                    ; (abg-kvp-value (gnc:kvp-frame-get-slot (gnc-transaction-get-slots trn) "IBRAnlageAbgangId"))
                                                    (trn-year (gnc:timepair-get-year (gnc-transaction-get-date-posted trn)))
                                                )

                                                (printf "bearbeite trn-num: %s\n" (xaccTransGetNum trn))
                                                (printf "posted: %s\n" (gnc-print-date (gnc-transaction-get-date-posted trn)))
                                                (printf "entered %s\n" (gnc-print-date (gnc-transaction-get-date-entered trn)))

                                                (map (lambda (split)

                                                        (if (or
                                                                (get-pseudo-kvp (xaccSplitGetMemo split) "AFA-NR")
                                                                (get-pseudo-kvp (xaccSplitGetMemo split) "ERW-NR")
                                                                (get-pseudo-kvp (xaccSplitGetMemo split) "ABG-NR"))
                                                            (if (= trn-year thisyear)
                                                                ; abschreibung in diesem jahr, fall a
                                                                (copy-afa-trn doc trn)
                                                            )
                                                        )

                                                        (if (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")
                                                            ; anlagen - split
                                                            (if (= trn-year thisyear)
                                                                ; eroeffnung in diesem jahr, fall b
                                                                (copy-afa-trn doc trn)
                                                                (let (
                                                                        (restwert (hash-ref restwerte (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                                                    )
                                                                    ; restwert muss >= 0 sein
                                                                    (if (= -1 (gnc-numeric-compare restwert numeric0))
                                                                        (html-add-text doc (redText "Warnung") "Restwert fuer xxx ist < 0: "
                                                                            (num-to-text restwert) "<br>")
                                                                    )
                                                                    (if (not (gnc-numeric-zero-p restwert))
                                                                        ; eroeffnung mit restwert (erinnerungswert), fall c
                                                                        (copy-afa-eroeffnung doc trn ab-anlagenaccount restwert thisyear split)
                                                                    )
                                                                )
                                                            )
                                                        )
                                                    )
                                                    (xaccTransGetSplitList trn)
                                                )

                                            )
                            
                                        )
                                        trnlist
                                    )
                                )
                            )
                            ab-anlagenaccounts
                        )

                        ; Done by session-destroy: (gnc:session-end afa-book-session)
                        (qof-session-destroy afa-book-session)
                    )
                    (html-add-text doc "AFA Buch konnte nicht geoeffnet werden (locked ?).")
                )

            )

        )

        doc
    )
)

; setzt einen numeric in ein hasch oder addiert zu einem im hash vorhandenen wert
(define (hash-set-add-numeric hash key value)

    (if (hash-ref hash key)
        (hash-set! hash key (gnc-numeric-add-fixed (hash-ref hash key) value))
        (hash-set! hash key value)
    )
)

; Hook for reload
(define (aspiegelRenderer report-obj)
    (let (
            (doc (gnc:make-html-document))
        )

        (_aspiegelRenderer report-obj doc)
    )
)

; Anlage spiegel erstellen
(define (_aspiegelRenderer report-obj doc)
    (let (
            ; (doc (gnc:make-html-document))
            ; (year (gnc:timepair-get-year (gnc:date-option-absolute-time (report-get-option report-obj gnc:pagename-general optname-date))))
            (startdate (gnc:timepair-start-day-time
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-from-date))))
            (enddate (gnc:timepair-end-day-time 
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-to-date))))
            (euroCurrency (gnc-commodity-table-lookup (gnc-commodity-table-get-table (gnc-get-current-book)) "ISO4217" "EUR"))
            ; (anlagenaccounts (get-anlagen-konten))
            (anlagenaccounts (find-accounts-has-desc-value-no-descendants doc "AFAKonto"))
            (book (gnc-get-current-book))
        )

        (html-add-text doc "<h2>Entwicklung Anlagevermoegen vom " (gnc-print-date startdate) " bis zum " (gnc-print-date enddate) "</h2>")
        (html-add-text doc "<p>Stand: " (gnc-print-date (gnc:get-today)) ", Betr&auml;ge in " (gnc-commodity-get-mnemonic euroCurrency) "</p>")

        ; nur im afa buch moeglich ...
        ; (if (afaBuchCheck doc) 
            ; (let (
                ; )

                ; Schleife ueber alle anlagen accounts
                (for-each (lambda (anlagenaccount)
                        (let (
                                ; (restwerte (berechne-afa-restwerte year (gnc-get-current-session) anlagenaccount))
                                (restwerte (berechne-afa-restwerte (gnc:timepair-previous-day startdate) book anlagenaccount))
                                (endwerte (berechne-afa-restwerte enddate book anlagenaccount))

                                (splits (query-split-by-account-and-enddate-all book anlagenaccount enddate))

                                ; html tabelle fuer diesen account
                                (table (gnc:make-html-table))
                                (anlagen '())
                                ; alle abgaenge bis einschliesslich dieses jahr
                                (abgaenge (make-hash-table 1))
                                ; alle erweiterungen bis einschliesslich dieses jahr
                                (erweiterungen (make-hash-table 1))
                                ; afa's dieses jahr
                                (afabuchungen (make-hash-table 1))
                                ; summe aller eroeffnungen
                                (sumanlagen (gnc-numeric-zero))
                                ; summe aller afa's
                                (sumafa (gnc-numeric-zero))
                                ; summe aller zuschreibungen
                                (sumerw (gnc-numeric-zero))
                                ; summe aller endwerte
                                (sumend (gnc-numeric-zero))
                                ; flag ob tabelle eintraege enthaelt
                                (table-not-empty #f)
                            )

                            ; Schleife ueber alle buchungen im anlagen konto
                            (for-each (lambda (split)
                                        
                                    (let (
                                            ; (splityear (gnc:timepair-get-year (gnc-transaction-get-date-posted (xaccSplitGetParent split))))
                                            (splitdate (gnc-transaction-get-date-posted (xaccSplitGetParent split)))
                                            (anl-nr (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR"))
                                            (erw-nr (get-pseudo-kvp (xaccSplitGetMemo split) "ERW-NR"))
                                            (afa-nr (get-pseudo-kvp (xaccSplitGetMemo split) "AFA-NR"))
                                            (abg-nr (get-pseudo-kvp (xaccSplitGetMemo split) "ABG-NR"))
                                        )
                                        (if anl-nr
                                            ; Anlagen buchung
                                            (set! anlagen (append anlagen (list split)))
                                        )
                                        (if erw-nr
                                            ; (if (= splityear year)
                                            (if ( and (gnc:timepair-ge splitdate startdate) (gnc:timepair-le splitdate enddate) )
                                                ; Buchung erweiterung/zuschreibung einer anlage
                                                (hash-set-add-numeric erweiterungen erw-nr (xaccSplitGetValue split))
                                            )
                                        )
                                        (if afa-nr
                                            ; (if (= splityear year)
                                            (if ( and (gnc:timepair-ge splitdate startdate) (gnc:timepair-le splitdate enddate) )
                                                ; AFA buchung
                                                (hash-set-add-numeric afabuchungen afa-nr (gnc-numeric-neg (xaccSplitGetValue split)))
                                            )
                                        )
                                        (if abg-nr
                                            ; Abgangs-buchung
                                            (hash-set! abgaenge abg-nr split)
                                        )
                                    )

                                )
                                splits
                            )

                            ; (display afabuchungen) (printf " <afa-afabuchungen\n")

                            (gnc:html-document-set-style! doc "table" 'attribute (list "border" 1))

                            (gnc:html-table-set-col-style! table 1 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 2 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 3 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 4 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 5 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 6 "td" 'attribute (list "align" "right"))
                            (gnc:html-table-set-col-style! table 7 "td" 'attribute (list "align" "right"))

                            (gnc:html-table-set-col-headers! table '("Inv.Nr <br> Bezeich." 
                                "Anschaff.<br>- Datum<br>- Kosten" "Wert 1.1." "Zuschreib.<br>Erweit."
                                "Meth.<br>ND<br>%" "Abg. Datum" "AFA" "Wert <br> 31.12."))

                            ; Schleife ueber alle anlagen - splits
                            (for-each (lambda (split)
                                    (let (
                                            (trn (xaccSplitGetParent split))
                                            (ndauer-string (get-pseudo-kvp (xaccSplitGetMemo split) "ND"))
                                            (prozent "--")
                                            (restwert (hash-ref restwerte (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                            (restwert-str #f)
                                            (erw-str "")
                                            (afavalue (hash-ref afabuchungen (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                            (erwvalue (hash-ref erweiterungen (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                            (abgsplit (hash-ref abgaenge (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                            (endwert (hash-ref endwerte (get-pseudo-kvp (xaccSplitGetMemo split) "ANL-NR")))
                                            ; (trn-year (gnc:timepair-get-year (gnc-transaction-get-date-posted (xaccSplitGetParent split))))
                                            (trn-date (gnc-transaction-get-date-posted (xaccSplitGetParent split)))
                                        )

                                        ; (display (xaccSplitGetValue afasplit)) (printf " <-afa value\n")

                                        ; (if (or restwert (= trn-year year))
                                        (if (or restwert (and (gnc:timepair-ge trn-date startdate) (gnc:timepair-le trn-date enddate) ))

                                            ; nur auflisten, falls restwert vorhanden, oder kauf in diesem yahr
                                            ; (if (or (= trn-year year) (not (gnc-numeric-zero-p restwert)))
                                            (if (or (and (gnc:timepair-ge trn-date startdate) (gnc:timepair-le trn-date enddate) ) (not (gnc-numeric-zero-p restwert)))
                                                (begin

                                                    (if restwert
                                                        (begin
                                                            (set! restwert-str (num-to-text (comm-umrechnung doc anlagenaccount restwert euroCurrency)))
                                                            (set! sumanlagen (gnc-numeric-add-fixed sumanlagen (comm-umrechnung doc anlagenaccount restwert euroCurrency)))
                                                        )
                                                        ; Kauf in diesem jahr, kein restwert vorhanden
                                                        (set! restwert-str "")
                                                    )

                                                    (if afavalue
                                                        (set! sumafa (gnc-numeric-add-fixed sumafa (comm-umrechnung doc anlagenaccount afavalue euroCurrency)))
                                                    )
                                                    (set! sumend (gnc-numeric-add-fixed sumend (comm-umrechnung doc anlagenaccount endwert euroCurrency)))
    
                                                    (if erwvalue
                                                        (begin
                                                            (set! sumerw (gnc-numeric-add-fixed sumerw (comm-umrechnung doc anlagenaccount erwvalue euroCurrency)))
                                                            (set! erw-str (num-to-text (comm-umrechnung doc anlagenaccount erwvalue euroCurrency)))
                                                        )
                                                    )

                                                    ; ndauer ist nicht gesetzt, falls afa buchungen noch nicht vorbereitet wurden
                                                    (if ndauer-string
                                                        (begin
                                                            (set! prozent (/ 100.0 (string->number ndauer-string)))
                                                        )
                                                        (set! ndauer-string "--")
                                                    )

                                                    (gnc:html-table-append-row! table (list
                                                        ; nummer, bezeichnung
                                                        (string-append (xaccTransGetNum trn) "<br>" (xaccTransGetDescription trn))
                                                        ; Anschaffungsdatum, wert
                                                        (string-append (gnc-print-date (gnc-transaction-get-date-posted trn)) "<br>" (num-to-text (comm-umrechnung doc anlagenaccount (xaccSplitGetValue split) euroCurrency)))
                                                        ; restwert 1.1.
                                                        restwert-str
                                                        ; zuschreibungen
                                                        erw-str
                                                        ; Methode
                                                        (string-append "linear<br>" ndauer-string "<br>" (sprintf #f "%.2f" prozent))
                                                        ; Abgang
                                                        (if abgsplit
                                                            (gnc-print-date (gnc-transaction-get-date-posted (xaccSplitGetParent abgsplit)))
                                                            ""
                                                        )
                                                        ; afa
                                                        (if afavalue
                                                            (num-to-text (comm-umrechnung doc anlagenaccount afavalue euroCurrency))
                                                            ""
                                                        )
                                                        ; rest 31.12.
                                                        (num-to-text (comm-umrechnung doc anlagenaccount endwert euroCurrency))
                                                    ))

                                                    ; tabelle enhaelt eintraege -> anzeigen
                                                    (set! table-not-empty #t)
                                                )
                                            )
                                            (html-add-text doc (redText "ERROR") ", Restwert fuer Anlage '" 
                                                (xaccTransGetDescription trn) "' (" (xaccTransGetNum trn) 
                                                ") konnte nicht berechnet werden !")
                                        )

                                    )
                                )
                                anlagen
                            )

                            (if table-not-empty
                                (begin
                                    (html-add-text doc "<h3>Konto: " (xaccAccountGetName anlagenaccount) "</h3>")

                                    (gnc:html-table-append-row! table (list
                                        "<h4>Summe</h4>"
                                        ""
                                        (string-append "<h4>" (num-to-text sumanlagen) "</h4>")
                                        (string-append "<h4>" (num-to-text sumerw) "</h4>")
                                        ""
                                        ""
                                        (string-append "<h4>" (num-to-text sumafa) "</h4>")
                                        (string-append "<h4>" (num-to-text sumend) "</h4>")
                                    ))
                                    (gnc:html-document-add-object! doc table)
                                )
                            )
                        )
                    )
                    anlagenaccounts
                )
            ; )
        ; )

        doc
    )
)

;  Plausibilitaets pruefungen:
;       - keine buchungen mit "99xx" konten, diese sind spezialkonten fuer unsere buchhaltung, 
;       die nicht beim SB auftauchen sollen !
(define (export-acc-mapping doc knr accountMapping)
    (begin

        (if (string=? (substring knr 0 2) "99")
            (html-add-text doc (redText "Fehler") ": 99xx konto soll exportiert werden !")
        )

        ; (printf "export: %s\n" (list-ref splitted 0))
        (if (hash-ref accountMapping knr)
            (begin
                (html-add-text doc (greenText "Wandle") " Kontonummer " knr " in " (hash-ref accountMapping knr) " um!<br>")
                (hash-ref accountMapping knr)
            )
            knr
        )
    )
)

(define lastCharWasNum #f)

(define (xnumberFilter char)

    ; (printf "c: '%c'" char)

    (if (char-numeric? char)
      (begin
        (set! lastCharWasNum #t)
        #f
      )
      (begin
        (if (and (char-whitespace? char) lastCharWasNum)
            (begin
                #f
            )
            (begin
                #t
                (set! lastCharWasNum #f)
            )
        )
      )
    )
)

(define (ynumberFilter char)

    ; (printf "c: '%c'" char)

    (if (or (char-numeric? char) (string-index "-/;:,." char))
      #f
    )
)

(define (numberFilter char)

    ; (printf "c: '%c'" char)

    (if (or (char-numeric? char) (char-set-contains? char-set:punctuation char))
      #f
    )
)

(define lastCharWasWS #f)

(define (wsFilter char)

    (if (char-whitespace? char)
        (if lastCharWasWS
           #f
           (begin
                (set! lastCharWasWS #t)
                #t
           )
        )
        (begin
            #t
            (set! lastCharWasWS #f)
        )
    )
)

; buchungsbetrag wird aus split 1 extrahiert !
(define (csv-export-teilbuchung doc outport trn split1 split2 accountMapping)
    (let (
            (splitvalue (xaccSplitGetValue split1))
            (trndesc (xaccTransGetDescription trn))
            (split1memo (xaccSplitGetMemo split1))
            ; (split2memo (xaccSplitGetMemo split2))
            (s "")
        )


        ; (string-filter s numberFilter)
        (set! lastCharWasNum #f)

        (if (not (= 100 (gnc-numeric-denom splitvalue)))
            (html-add-text doc (redText "Fehler") ": denom ist nicht 100 !")
        )

        ; XXX COMPAT bug in altem export, folgende zeile nur fuer vergleich zur alten version !!!!!!!!!!
        ; (set! trndesc (string-append trndesc ";"))

        (set! trndesc (string-append trndesc " " split1memo))

        ; trn_desc=trn.getattr(default:''; attr:'_opt_trn_description')
        ; trn_desc=trn_desc+"; "+memo

        ; es wird immer soll an haben exportiert, das heisst, falls splitvalue >= 0 ist wird
        ; der betrag negiert und die konten entsprechend vertauscht !!!!!!!!!!

        ; 1. "Buchungsbetrag --> "Umsatz"
        (if (= -1 (gnc-numeric-compare splitvalue numeric0))
            ; soll betrag, split 1 ist soll split, split 2 ist haben split
            (display (number->string (gnc-numeric-num (gnc-numeric-neg splitvalue))) outport)
            ; soll betrag, split 2 ist soll split, split 1 ist haben split, umpolen
            (display (number->string (gnc-numeric-num splitvalue)) outport)
        )
        (display "s;" outport)

        ; 2. BU-Schluessel
        (display ";" outport)

        ; 3. Gegenkonto == Habenkonto
        (if (= -1 (gnc-numeric-compare splitvalue numeric0))    
            ; split 1 ist soll split, split 2 ist haben split
            (display (export-acc-mapping doc (get-account-knr doc (xaccSplitGetAccount split1)) accountMapping) outport)
            ; split 2 ist soll split, split 1 ist haben split
            (display (export-acc-mapping doc (get-split-knr doc split2) accountMapping) outport)
        )
        (display ";" outport)

        ; 4. Belegnummer --> "Belegfeld1"
        (display "\"" outport)
        (display (xaccTransGetNum trn) outport)
        (display "\";" outport)

        ; 5. "Belegfeld2"
        (display ";" outport)

        ; 6. "Belegdatum", DDMM
        (display (sprintf #f "%02d" (gnc:date-get-month-day (gnc:timepair->date (gnc-transaction-get-date-posted trn)))) outport)
        (display (sprintf #f "%02d" (gnc:timepair-get-month (gnc-transaction-get-date-posted trn))) outport)
        (display ";" outport)
        
        ; 7. Konto == Sollkonto
        (if (= -1 (gnc-numeric-compare splitvalue numeric0))    
            ; split 1 ist soll split, split 2 ist haben split
            (display (export-acc-mapping doc (get-account-knr doc (xaccSplitGetAccount split2)) accountMapping) outport)
            ; split 2 ist soll split, split 1 ist haben split
            (display (export-acc-mapping doc (get-split-knr doc split1) accountMapping) outport)
        )
        (display ";" outport)


        ; 8., 9., 10., 11. Kostfeld 1 + 2, Kostmenge, Skonto
        (display ";;;;" outport)

        ; 12. Buchungstext";
        (printf "s: '%s'\n" trndesc)
        (set! s (string-filter (string-trim-both (string-filter trndesc numberFilter) char-set:whitespace) wsFilter))

        (if (> (string-length s) 30)
            (printf "S: '%s'\n" (substring s 0 30))
            (printf "S: '%s'\n" s)
        )

        ; (set! trndesc (string-filter (string-trim-both (string-filter trndesc numberFilter) char-set:whitespace) wsFilter))
        (display "\"" outport)
        ; (if (> (string-length trndesc) 30)
            ; (display (substring trndesc 0 30) outport)
            ; (begin
                ; (set! trndesc (string-filter (string-trim-both (string-filter trndesc numberFilter) char-set:whitespace) wsFilter))
                ; (if (> (string-length trndesc) 30)
                    ; (display (substring trndesc 0 30) outport)
                    ; (display trndesc outport)
                ; )
            ; )
            (display trndesc outport)
        ; )
        (display "\";" outport)

        ; 13. ...EULand + EuSteuersatz + Waehrungskennung + Basiswaehrungsbetrag + 
        ; + Basiswaehrungskennung + kurs
        (display ";;;;;;" outport)

        (display "\n" outport)
    )
)

(define (get-numeric-sign value)
    ;(/ (gnc-numeric-num value) (gnc-numeric-num (gnc-numeric-abs value)))
    (if (= (gnc-numeric-compare value numeric0) -1)
        -1
        1
    )
)

; aufteilung der splits in brutto- und gegensplits
(define (get-brutto-split doc trn)
    (let (
            ; erstes element: brutto split, zweites element die restlichen splits
            (othersplits '())
            (bruttosplit #f)
            (bruttosign #f)
            (bruttovalue #f)
            (maxvalue (gnc-numeric-zero))
            (splits (xaccTransGetSplitList trn))
        )
        ; maximalen wert suchen
        (map (lambda (split)
                (let (
                        (svalue (xaccSplitGetValue split))
                    )
                    (if (= (gnc-numeric-compare (gnc-numeric-abs svalue) maxvalue) 1)
                        (begin
                            (set! maxvalue (gnc-numeric-abs svalue))
                            (set! bruttovalue svalue)
                            (set! bruttosign (get-numeric-sign svalue))
                        )
                    )
                )
            )
            splits
        )

        (if bruttovalue
            (begin
                ; splits aufteilen, fehler behandlung
                (map (lambda (split)
                        (let (
                                (svalue (xaccSplitGetValue split))
                            )
                            (if (= (gnc-numeric-compare svalue bruttovalue) 0)
                                (set! bruttosplit split)
                                (begin
                                    (set! othersplits (append othersplits (list split)))
                                    ; check sign
                                    (if (= bruttosign (get-numeric-sign svalue))
                                        (begin
                                            (html-add-text doc "<br>Ungueltige anzahl splits in transaktion ")
                                            (html-add-trn doc trn)
                                            (html-add-text doc ", brutto split nicht gefunden ! <br><br>")
                                        )
                                    )
                                )
                            )
                        )
                    )
                    splits
                )
            )
            (begin
                (html-add-text doc "<br>" (redText "Error") ", brutto split nicht gefunden transaktion: ")
                (html-add-trn doc trn)
                (html-add-text doc "<br><br>")
            )
        )

        ; (display (xaccSplitGetValue bruttosplit)) (printf " <- brutto split value, sign: %d\n" bruttosign)

        (list bruttosplit othersplits)
    )
)

(define (my-string-replace-char s old new)
  (string-map (lambda (c) (if (char=? c old) new c)) s))

(define (getAccountMapping doc)
    (let (
            (accountMapping (make-hash-table 1))
            (renamedAccounts (find-accounts-has-desc-value doc "ExportKNR"))
        )

        (map (lambda (renamedAccount)
                (hash-set! accountMapping (get-account-knr doc renamedAccount) (get-desc-value "ExportKNR" doc renamedAccount #t))
            )
            renamedAccounts
        )

        ; (display accountMapping) (printf "<accountMapping\n")

        accountMapping
    )
)

; Hook for reload
(define (csvexportRenderer report-obj)
    (_csvexportRenderer report-obj)
)

(define (_csvexportRenderer report-obj)

    (let (
            (doc (gnc:make-html-document))
            (book (gnc-get-current-book))
            ; String-replace wegen LANG variable
            (today-str (my-string-replace-char (gnc-print-date (gnc:get-today))  #\/ #\.))
            ; Path
            (pathname (build-path (getenv "HOME") "gnc_csv_export"))
            (startdate (gnc:timepair-start-day-time
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-from-date))))
            (enddate (gnc:timepair-end-day-time 
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-to-date))))
            (euroCurrency (gnc-commodity-table-lookup (gnc-commodity-table-get-table (gnc-get-current-book)) "ISO4217" "EUR"))
            (do-export (report-get-option report-obj gnc:pagename-general optname-run-cvs-export))
        )

        (html-add-text doc "<h2>Ergebnis CSV Export:</h2>")

        ; nicht im afa buch moeglich ...
        (if do-export

            (let (
                    ; Dateiname
                    ;; (filename (build-path pathname (string-append (number->string (get-this-year book)) "_" today-str ".csv")))
                    (filename (build-path pathname (string-append (number->string (gnc:timepair-get-year startdate)) "_" today-str ".csv")))
                    (outport #f)
                )

                (html-add-text doc "<p>Exportiere Buchungen vom " (gnc-print-date startdate) " bis zum " (gnc-print-date enddate) "</p>")
                (html-add-text doc "Dateiname: " filename "<br><br>")

                ; Ignore exception if directory exists.
                (false-if-exception (mkdir pathname))
                (set! outport (false-if-exception (open-output-file filename)))

                (if outport
                    (let (
                            ; (query (gnc:malloc-query))
	                        (query (qof-query-create-for-splits))
                            (num-trn 0)
                            (accountMapping (getAccountMapping doc))
                        )

                        ; Select alle transaktionen vom 1.1. bis zum 31.12.
                        (qof-query-set-book query book)
                        ; (gnc:query-add-date-match-timepair query 
                            ; #f startdate
                            ; #t enddate 'query-and)
                        (xaccQueryAddDateMatchTS query
                             #t startdate
                             #t enddate QOF-QUERY-AND)
                        (qof-query-set-sort-order query (list QUERY-DEFAULT-SORT) '() '())

                        ; Problem: wir wollen eigentlich alle splits exportieren, ein split betrifft aber
                        ; nur ein konto, so dass sich die frage nach dem gegenkonto auftut. Wir muessen
                        ; also ueber die transaktion gehen.
                        ; Falls die Transaktion nur 2 splits enthaelt ist das kein problem.
                        ; Falls 3 oder mehr splits vorhanden sind, so muss der brutto split gefunden werden und der
                        ; wert auf die anderen verteilt werden.

                        ; Schleife ueber alle transaktionen
                        (map (lambda (trn)
                                (let (
                                        (bruttosplit #f)
                                        (othersplits #f)
                                        (splitted (get-brutto-split doc trn))
                                        (exportTrn #t)
                                    )

                                    (set! bruttosplit (list-ref splitted 0))
                                    (set! othersplits (list-ref splitted 1))

                                    ;
                                    ; Nur exportieren, falls nicht descvalue "NoExport" gesetzt ist:
                                    ;
                                    (if (and bruttosplit (get-desc-value "NoExport" doc (xaccSplitGetAccount bruttosplit) #t))
                                        (set! exportTrn #f)
                                    )
                                    (map (lambda (split)
                                            (if (get-desc-value "NoExport" doc (xaccSplitGetAccount split) #t)
                                                (set! exportTrn #f)
                                            )
                                        )
                                        othersplits
                                    )

                                    (if (and bruttosplit exportTrn)
                                        (begin

                                            (html-add-text doc "Export Buchung '" (xaccTransGetDescription trn) "'<br>")

                                            (if (not (gnc-commodity-equiv euroCurrency (xaccAccountGetCommodity (xaccSplitGetAccount bruttosplit))))
                                                (html-add-text doc "<br>" (redText "WARNUNG") ", Split nicht in EUR Waehrung: " (xaccSplitGetMemo bruttosplit))
                                            )

                                            (map (lambda (split)
                                                    (if (not (gnc-commodity-equiv euroCurrency (xaccAccountGetCommodity (xaccSplitGetAccount split))))
                                                        (html-add-text doc "<br>" (redText "WARNUNG") ", Split nicht in EUR Waehrung: " (xaccSplitGetMemo split))
                                                    )
                                                    (if (not (get-desc-value "NoExport" doc (xaccSplitGetAccount bruttosplit) #t))
                                                        (csv-export-teilbuchung doc outport trn split bruttosplit accountMapping)
                                                        (html-add-text doc (greenText "Skipping") " 'NoExport' Transaction '" (xaccTransGetDescription trn) "'<br>")
                                                    )

                                                )
                                                othersplits
                                            )

                                            (set! num-trn (+ num-trn 1))
                                        )
                                        (html-add-text doc (greenText "&Uuml;berspringe") " 'NoExport' Transaktion: '" (xaccTransGetDescription trn) "'<br>")
                                    )
                                )
                            )
                            ;(gnc:query-get-transactions query 'query-txn-match-any)
                            (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
                        )

                        ;(gnc:free-query query)
                        (qof-query-destroy query)
                        (close-port outport)
                        (html-add-text doc "<br>Es wurden " (number->string num-trn) " Buchungen exportiert.")
                    )
                    (html-add-text doc "Ausgabe Datei konnte nicht geoeffnet werden !")
                )

            )

            (html-add-text doc (redText "Warnung:") " Option '" optname-run-cvs-export "' nicht gesetzt")
        )

        doc
    )
)

(define (buchungsCheckRenderer report-obj)

    (let (
            (doc (gnc:make-html-document))
            (book (gnc-get-current-book))
            (startdate (gnc:timepair-start-day-time
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-from-date))))
            (enddate (gnc:timepair-end-day-time 
                (gnc:date-option-absolute-time 
                    (report-get-option report-obj gnc:pagename-general optname-to-date))))
        )

        (html-add-text doc "<h2>Ergebnis Buchungs-Check:</h2>")

        (html-add-text doc "<p>Es wird geprueft, ob die Buchungen auf die geforderten Gegenkonten durchgefuehrt wurden.</p>")

        (html-add-text doc "<p>Pr&uuml;fe Buchungen vom " (gnc-print-date startdate) " bis " (gnc-print-date enddate) "</p>")

        (map 
            (lambda (checkaccount)
                (let (
                        (gkandlist (get-desc-values "GK" doc checkaccount))
                    )

                    ; (printf "GKandlist:'\n")
                    ; (display gkandlist) (printf "<gkandlist\n")

                    (map
                        (lambda (andgk)

                            (let (
                                    (query (qof-query-create-for-splits))
                                    ; (gk (get-gegenkonto-by-desc-value doc "GK" checkaccount))
                                    (gkorlist (string-split andgk #\|))
                                )
        
                                ; (printf "GK:  '%s'\n" andgk)
                                ; (display gkorlist) (printf "<splitted\n")
        
                                (html-add-text doc (greenText "<p>Konto") " '" (xaccAccountGetCode checkaccount) "' '" (xaccAccountGetDescription checkaccount)  "'</p>")
        
                                (qof-query-set-book query (gnc-get-current-book))
                                (xaccQueryAddSingleAccountMatch query checkaccount QOF-QUERY-AND)
                                (xaccQueryAddDateMatchTS query #t startdate #t enddate QOF-QUERY-AND)
        
                                (map 
                                    (lambda (trn)
                                        (let
                                            (
                                                (gksplit-found #f)
                                            )
                                            (map 
                                                (lambda (orgk)
                                                    (let
                                                        (
                                                            (gkaccount (find-acc-by-code orgk))
                                                        )
                                                        (if gkaccount
                                                            (map 
                                                                (lambda (split)
                                                                    (if (string=? (gncAccountGetGUID gkaccount) (gncAccountGetGUID (xaccSplitGetAccount split)))
                                                                        (set! gksplit-found #t)
                                                                    )
                                                                )
                                                                (xaccTransGetSplitList trn)
                                                            )
                                                        )
                                                    )
                                                )
                                                gkorlist
                                            )

                                            (if (not gksplit-found)
                                                (begin
                                                    (html-add-text doc (redText "NOTOK ") "Keine Buchung nach Gegenkonto: '")
                                                    (html-add-trn doc trn)
                                                    (html-add-text doc "'<br>")
                                                )
                                            )
                                        )
                                    )
                                    (xaccQueryGetTransactions query QUERY-TXN-MATCH-ANY)
                                )
                                (qof-query-destroy query)
                            )
                        )
                        gkandlist
                    )

                )
            )
            (find-accounts-has-desc-value doc "GK")
        )
        doc
    )
)

; Report ausfuerhen
(define (runReport window reportname saveit)
    (let (
            (report-id (gnc:make-report reportname))
        )

        ; do not save this thing, xxx does not work ?
        ; (load-from-path "report.scm")
        ; (gnc:report-set-needs-save?! (gnc-report-find report-id) saveit)
        (gnc:report-set-needs-save?! (gnc-report-find report-id) #f)

        (gnc-main-window-open-report report-id window)
    )
)

(define (define-result-report name report-guid renderer)
    (define (options-generator)
        (let ((options (gnc:new-options)))
        options))

    (gnc:define-report
        'version 1
        'name name
        'report-guid report-guid
        'options-generator options-generator
        'renderer renderer
        'in-menu? #f
    )
)

(define (date-interval-options-generator)
    (let (
            (options (gnc:new-options))
        )

        ; (gnc:options-add-date-interval!
            ; options gnc:pagename-general
            ; optname-from-date optname-to-date "a")

        ; (gnc:option-set-value
            ; (gnc:lookup-option options gnc:pagename-general optname-from-date)
            ; (cons 'relative 'start-this-year))
            ;
        ; (vector-set!
            ; (gnc:lookup-option options gnc:pagename-general optname-from-date)
            ; 7
            ; (lambda () (cons 'relative 'start-cal-year)))

        ; (gnc:option-set-value
            ; (gnc:lookup-option options gnc:pagename-general optname-to-date)
            ; (cons 'relative 'end-this-year))


        (gnc:register-option 
        options  
        (gnc:make-date-option
            gnc:pagename-general optname-from-date
            "a" (N_ "Start of reporting period")
            (lambda () (cons 'relative 'start-cal-year))
            #f 'both 
            '(
            today
            start-this-month 
            start-prev-month 
            start-current-quarter
            start-prev-quarter
            start-cal-year 
            start-prev-year
            start-accounting-period
            )))

        (gnc:register-option 
        options  
        (gnc:make-date-option
            gnc:pagename-general optname-to-date
            "b" (N_ "End of reporting period")
            (lambda () (cons 'relative 'end-cal-year))
            #f 'both 
            '(
            today 
            end-this-month
            end-prev-month 
            end-current-quarter 
            end-prev-quarter
            end-cal-year 
            end-prev-year
            end-accounting-period
            )))

        options
    )
)

(define (ust-options-generator)
    (let (
            (options (gnc:new-options))
        )

        ; (gnc:options-add-date-interval!
            ; options gnc:pagename-general
            ; optname-from-date optname-to-date "a")

        ; (gnc:option-set-value
            ; (gnc:lookup-option options gnc:pagename-general optname-from-date)
            ; (cons 'relative 'start-this-year))
            ;
        ; (vector-set!
            ; (gnc:lookup-option options gnc:pagename-general optname-from-date)
            ; 7
            ; (lambda () (cons 'relative 'start-cal-year)))

        ; (gnc:option-set-value
            ; (gnc:lookup-option options gnc:pagename-general optname-to-date)
            ; (cons 'relative 'end-this-year))


        (gnc:register-option options  
          (gnc:make-date-option
            gnc:pagename-general optname-from-date
            "a" (N_ "Start of reporting period")
            (lambda () (cons 'relative 'start-cal-year))
            #f 'both 
            '(
            today
            start-this-month 
            start-prev-month 
            start-current-quarter
            start-prev-quarter
            start-cal-year 
            start-prev-year
            start-accounting-period
            )))

        (gnc:register-option options  
          (gnc:make-date-option
            gnc:pagename-general optname-to-date
            "b" (N_ "End of reporting period")
            (lambda () (cons 'relative 'end-cal-year))
            #f 'both 
            '(
            today 
            end-this-month
            end-prev-month 
            end-current-quarter 
            end-prev-quarter
            end-cal-year 
            end-prev-year
            end-accounting-period
            )))

        (gnc:register-option options  
            (gnc:make-simple-boolean-option
                  gnc:pagename-general optname-enter-tax-splits
                  "c"
                  optname-enter-tax-splits
                  #f))

        options
    )
)

(define (csv-export-options-generator)
    (let (
            (options (gnc:new-options))
        )

        (gnc:register-option options  
          (gnc:make-date-option
            gnc:pagename-general optname-from-date
            "a" (N_ "Start of reporting period")
            (lambda () (cons 'relative 'start-prev-year))
            #f 'both 
            '(
            today
            start-this-month 
            start-prev-month 
            start-current-quarter
            start-prev-quarter
            start-cal-year 
            start-prev-year
            start-accounting-period
            )))

        (gnc:register-option options  
          (gnc:make-date-option
            gnc:pagename-general optname-to-date
            "b" (N_ "End of reporting period")
            (lambda () (cons 'relative 'end-prev-year))
            #f 'both 
            '(
            today 
            end-this-month
            end-prev-month 
            end-current-quarter 
            end-prev-quarter
            end-cal-year 
            end-prev-year
            end-accounting-period
            )))

        (gnc:register-option options  
            (gnc:make-simple-boolean-option
                  gnc:pagename-general optname-run-cvs-export
                  "c"
                  optname-run-cvs-export
                  #f))

        options
    )
)

(define ibr-menu-name (N_ "_IngRieger"))

(define (ibr-init)
  (if (not ibr-menu-created)
    (let (
            (menu-path (list (N_ "Extensions") ibr-menu-name))
        )

        (printf "Creating ibr-menu, GnuCash version: %s\n" gnc:version)

        (load-from-path "gnc-menu-extensions.scm")

        ;
        ; Menue erzeugen
        ;
        (gnc-add-scm-extension 
            (gnc:make-menu ibr-menu-name (list "Extensions"))
        )

        ; Buchungs - pruefung
        (gnc:define-report
            'version 1
            'name "BuchungsCheck"
            'report-guid buchungs-check-guid
            'options-generator date-interval-options-generator
            'renderer buchungsCheckRenderer
            'in-menu? #f
        )
        (gnc-add-scm-extension (
            gnc:make-menu-item
            (N_ "A Pruefung Buchungen")
            buchungs-check-menu-guid
            (N_ "Pruefung Buchungen")
            menu-path
            (lambda (window) (runReport window buchungs-check-guid #f))
            )
        )

        ; UST pruefung
        (gnc:define-report
            'version 1
            'name "USTErgebnis"
            'report-guid ust-check-guid
            'options-generator ust-options-generator
            'renderer ustRenderer
            'in-menu? #f
        )
        (gnc-add-scm-extension (
            gnc:make-menu-item
            (N_ "B Pruefung UST")
            ust-check-menu-guid
            (N_ "Pruefung UST Buchungen")
            menu-path
            (lambda (window) (runReport window ust-check-guid #f))
            )
        )

        ;;;;; ; UST pruefung mit anlegen der buchungen
        ;;;;; (gnc:define-report
            ;;;;; 'version 1
            ;;;;; 'name "USTBuchungen"
            ;;;;; 'report-guid ust-auto-guid
            ;;;;; 'options-generator safe-date-interval-options-generator
            ;;;;; 'renderer ustRenderer
            ;;;;; 'in-menu? #f
        ;;;;; )
        ;;;;; (gnc-add-scm-extension (
            ;;;;; gnc:make-menu-item
            ;;;;; (N_ "B UST Buchungen anlegen")
            ;;;;; (N_ "UST Buchungen anlegen")
            ;;;;; menu-path
            ;;;;; (lambda (window) (runReport window ust-auto-guid #f))
            ;;;;; )
        ;;;;; )

        ; Pruefung Jahres-Abschluss
        ; (define-result-report "JAErgebnis" ja-guid jaRenderer)

        ; UST pruefung
        (gnc:define-report
            'version 1
            'name "JAErgebnis"
            'report-guid ja-guid
            'options-generator date-interval-options-generator
            'renderer jaRenderer
            'in-menu? #f
        )
        (gnc-add-scm-extension (
            gnc:make-menu-item
            (N_ "C Pruefung Jahresabschluss")
            ja-menu-guid
            (N_ "Pruefung auf korrekten Jahresabschluss des aktuellen Buches")
            menu-path
            (lambda (window) (runReport window ja-guid #f))
            )
        )

        ;;;;;;;; definiere JU result report
        ;;;;;;;(define-result-report "JUErgebnis" ju-guid juRenderer)

        ;;;;;;;(gnc-add-scm-extension (
            ;;;;;;;gnc:make-menu-item
            ;;;;;;;(N_ "D Pruefung Jahresuebergaenge")
            ;;;;;;;(N_ "Pruefung auf korrekte Jahresuebergaenge aller Buecher")
            ;;;;;;;menu-path
            ;;;;;;;(lambda (window) (runReport window ju-guid #f))
            ;;;;;;;)
        ;;;;;;;)

        (gnc-add-scm-extension (gnc:make-extension 'separator "CCSeparator" cc-sep-guid "" menu-path #f))

        ; Definiere CSV Export bericht
        (gnc:define-report
            'version 1
            'name "CSVExport"
            'report-guid csv-export-guid
            'options-generator csv-export-options-generator
            'renderer csvexportRenderer
            'in-menu? #f
        )
        (gnc-add-scm-extension (
            gnc:make-menu-item
            (N_ "D CSV Export")
            csv-export-menu-guid
            (N_ "Buchungen als CSV Datei exportieren (fuer Steuerberater)")
            menu-path
            (lambda (window) (runReport window csv-export-guid #f))
            )
        )

        (gnc-add-scm-extension (gnc:make-extension 'separator "DDSeparator" dd-sep-guid "" menu-path #f))

        ; Menue eintrag anlage spiegel
        (gnc:define-report
            'version 1
            'name "AFASpiegel"
            'report-guid afa-spiegel-guid
            'options-generator date-interval-options-generator
            'renderer aspiegelRenderer
            'in-menu? #f
        )

        ; Menue eintrag anlage spiegel
        (gnc-add-scm-extension (gnc:make-menu-item
            (N_ "E Anlagen Spiegel")
            afa-spiegel-menu-guid
            (N_ "Report Anlage Spiegel")
            menu-path
            (lambda (window) (runReport window afa-spiegel-guid #t))))

        ; definiere AFA vorbereiten result report
        (define-result-report  "AFAVorbereitung" afa-vorbereitung-guid afavRenderer)

        ; Menue eintrag afa vorbereitung
        (gnc-add-scm-extension (gnc:make-menu-item 
            (N_ "F AFA Buchungen Vorbereiten")
            afa-vorbereitung-menu-guid
            (N_ "AFA Buchungen im Gnucash-Abschreibungs-Buch vorbereiten")
            menu-path
            (lambda (window) (runReport window afa-vorbereitung-guid #f))))

        ;; ; definiere AFA uebernahme result report
        ;; (define-result-report "AFAUebernahme" afa-uebernahme-guid afauRenderer)

        ;; ; Menue eintrag afa daten uebernehmen
        ;; (gnc-add-scm-extension (gnc:make-menu-item
            ;; (N_ "G AFA Daten uebernehmen")
            ;; (N_ "Uebernahme der AFA daten in das aktuelle buch")
            ;; menu-path
            ;; (lambda (window) (runReport window afa-uebernahme-guid #f))))

        (if ibr-debug
            (begin

                (gnc-add-scm-extension (gnc:make-extension 'separator "FFSeparator" ff-sep-guid "" menu-path #f))

                (gnc-add-scm-extension (
                    gnc:make-menu-item
                    (N_ "G DEBUG Reload ibr-gnc-module")
                    reload-ibr-gnc-module-menu-guid
                    (N_ "DEBUG ibr-gnc-module.scm neu laden")
                    menu-path
                    (lambda (window)
                        (let (
                                (path (build-path (getenv "HOME") "gncdata/ibr-gnc-module.scm"))
                                )
                                (primitive-load path)
                            )
                        )
                    )
                )
            ) ; begin
        ) ; if ibr-debug

        (printf "Create ibr-menu done\n")

        (set! ibr-menu-created #t)

    )
  )
)

(printf "End ibr-gnc-module.scm\n")


#!

OLD Stuff:

(define (pruefeJUBuch company-name prevyearsession prevyear doc)
    (let (
        (nextyearsession (openSessionOrCurrent (string-append company-name (number->string (+ prevyear 1)) ".gnc")))
        ; (prevyearaccounts (gnc:book-get-group (qof-session-get-book prevyearsession)))
        (prevyearaccounts (gnc-book-get-root-account (qof-session-get-book prevyearsession)))
        )

        (if nextyearsession
            (let (
                    ; (prevaktivaaccount (find-acc-in-childs-by-code prevyearaccounts "1000"))
                    (prevaktivaaccount (find-acc-by-code-with-root-account prevyearaccounts "1000"))
                    (nextbook (qof-session-get-book nextyearsession))
                )
                (html-add-text doc 
                    "<h4>&Uuml;bergang " (number->string prevyear) " - " (number->string (+ prevyear 1)) "</h4>")

                ; Pruefung
                ; - hole alle bankkonten aus altem jahr und bestimme saldo
                ; - suche im neuen jahr die eroeffnungsbuchung im entsprechenden konto
                ;   (nummer 0, muss vorhanden sein) und vergleiche saldo

                (if prevaktivaaccount
                    (for-each 
                        (lambda (account)
                            (if (string=? (substring (get-account-knr doc account) 0 2) "18")
                                ; bank account gefunden, saldo feststellen
                                (let (
                                    ; (nextbankaccount (find-acc-in-childs-by-code 
                                        ; (gnc:book-get-group nextbook)
                                        ; (get-account-knr doc account)))
                                    (nextbankaccount (find-acc-by-code-with-root-account prevyearaccounts (get-account-knr doc account)))
                                    (prevsaldo (xaccAccountGetBalance account))
                                    )
                                    (if nextbankaccount
                                        (let (
                                                (splits (query-by-account-and-num nextbook nextbankaccount "^0$"))
                                            )
                                            (if (null? splits)
                                                (if (not (gnc-numeric-zero-p prevsaldo)) ; Fehlendes konto ok falls vorjahr 0
                                                    (html-add-text doc
                                                        "Keine buchung mit nummer 0 in konto " (get-account-knr doc account) " in " 
                                                        (number->string (+ prevyear 1)) " gefunden " (redText "NOTOK") "<br>")
                                                )
                                                (juVergleich doc account prevsaldo nextbankaccount splits)
                                            )
                                        )
                                        (if (not (gnc-numeric-zero-p prevsaldo)) ; Fehlendes konto ok falls vorjahr 0
                                            (html-add-text doc
                                                "Konto " (get-account-knr doc account) " in Jahr " 
                                                (number->string (+ prevyear 1)) " nicht gefunden !<br>")
                                        )
                                    )
                                )
                            )
                        )
                        (gnc-account-get-descendants-sorted prevaktivaaccount)
                    )
                    (html-add-text doc "Aktiva konto 1000 nicht gefunden !<br>")
                )

                ; Schliesse erstes buch, bearbeite naechsten ju, rekursion
                (closeSessionNotCurrent prevyearsession)
                (pruefeJUBuch company-name nextyearsession (+ prevyear 1) doc)
            )
            (closeSessionNotCurrent prevyearsession)
        )
    )
)

;;;;;;;(define (find-first-book company-name year max-year)
    ;;;;;;;(let (
            ;;;;;;;; XXX extension hardcoded
            ;;;;;;;(path (string-append (gnc-book-path company-name) (number->string year) ".gnc"))
        ;;;;;;;)

        ;;;;;;;(printf "path %s\n" path)

        ;;;;;;;(if (false-if-exception (open-input-file path))
           ;;;;;;;; open ok
           ;;;;;;;year
           ;;;;;;;; open failed
           ;;;;;;;(if (< year max-year)
             ;;;;;;;(find-first-book company-name (+ year 1) max-year)
             ;;;;;;;#f
           ;;;;;;;)
        ;;;;;;;)
        ;;;;;;;; (and (jahrBuchCheck doc) (ustPruefung doc report-obj))
        ;;;;;;;; doc
    ;;;;;;;)
;;;;;;;)

; "Pruefung auf korrekte jahresuebergaenge aller buecher"
;;;;;;;(define (juRenderer report-obj)
    ;;;;;;;(let* (
            ;;;;;;;(doc (gnc:make-html-document))
	        ;;;;;;;(slots (gnc-book-get-slots (gnc-get-current-book)))
	        ;;;;;;;(company-name (kvp-frame-get-slot-path-gslist
                ;;;;;;;slots (append gnc:*kvp-option-path*
                    ;;;;;;;(list gnc:*business-label* gnc:*company-name*))))
            ;;;;;;;(first-year 1990)
            ;;;;;;;; (max-year (+ (tm:year (localtime (current-time))) 1900))
            ;;;;;;;(max-year (gnc:date-get-year (localtime (current-time))))
        ;;;;;;;)

        ;;;;;;;(html-add-text doc "<h2>Ergebnis Pr&uuml;fung der Jahres&uuml;bergaenge:</h2>")

        ;;;;;;;(if company-name
            ;;;;;;;(begin
                ;;;;;;;(printf "firmenname: %s\n" company-name)
                ;;;;;;;(printf "lastyear: %d\n" max-year)

                ;;;;;;;; Ersts geschaeftjahr suchen:
                ;;;;;;;(set! first-year (find-first-book company-name first-year max-year))

                ;;;;;;;(printf "firstyear %d\n" first-year)

                ;;;;;;;(if first-year
                    ;;;;;;;(let (
                            ;;;;;;;(prevyearsession (openSessionOrCurrent (string-append company-name (number->string first-year) ".gnc")))
                        ;;;;;;;)
                        ;;;;;;;; start mit 1996, dann rekursiver aufruf von pruefeJUBuch mit naechstem jahr
                        ;;;;;;;(pruefeJUBuch company-name prevyearsession first-year doc)
                    ;;;;;;;)
                ;;;;;;;)
            ;;;;;;;)
            ;;;;;;;(html-add-text doc "<br>" (redText "Error") ", Firmenname nicht eingestellt (Datei->Eigenschaften->Firmenname).")
        ;;;;;;;)
        ;;;;;;;doc
    ;;;;;;;)
;;;;;;;)

; remove
; Pruefung jahresabschluss, vergleich prevvalue mit nextvalue, vorraussetzung:
; gleiche waehrung
(define (juValueVergleich doc prevaccount prevvalue nextaccount nextvalue)
    (let (
            (bankknr (get-account-knr doc prevaccount))
        )
        (if (= 0 (gnc-numeric-compare prevvalue nextvalue))
            (html-add-text doc "Eroeffnung fuer Konto " bankknr (greenText " OK") "<br>")

            (html-add-text doc 
                "Konto " bankknr ", Saldo: " (num-account-comm-to-text prevvalue nextaccount)
                " stimmt nicht mit eroeffnungs wert: " (num-account-comm-to-text nextvalue nextaccount)
                " ueberein " (redText "NOTOK") "<br>")
        )
    )
)

; remove
(define (juVergleich doc prevaccount prevsaldo nextaccount nextsplits)
    (let (
            (splitvalue (xaccSplitGetValue (car nextsplits)))
            (prev-account-currency (xaccAccountGetCommodity prevaccount))
            (next-account-currency (xaccAccountGetCommodity nextaccount))
        )

        (if (waehrungs-vergleich prev-account-currency next-account-currency)
            (juValueVergleich doc prevaccount prevsaldo nextaccount splitvalue)
            ; verschiedene waehrungen, kann nur bedeuten, dass das letzte jahr in DM und das neue jahr in
            ; EURO sind. Wert aus letztem jahr in euro umrechnen
            (juValueVergleich doc prevaccount 
                (gnc-convert-to-euro prev-account-currency prevsaldo) nextaccount splitvalue)
        )
    )
)

!#

